; ID: 2933
; Author: RemCoder
; Date: 2012-03-14 05:56:25
; Title: Basic character controls with FirstPerson view or ThirdPerson view
; Description: (forward, backward, left, right, jump, fall, land) + collisions Player<->Level

GWidth% = 800
GHeight% = 600
GColors% = 32
GMode% = 2
Graphics3D(GWidth%,GHeight%,GColors%,GMode%)  
HidePointer()  
SeedRnd(MilliSecs())  

Const FirstPerson% = 1
Const ThirdPerson% = 2
 
Const CollLevel% = 10
Const CollPlayer% = 11
 
Global Camera = CreateCamera()  
CameraRange(Camera,0.1,1000)
CameraClsColor(Camera,000,000,000)  
PositionEntity(Camera,0,0,0)  

Origine = CreateCube()  
ScaleMesh(Origine,0.1/2,1024.0,.01/2)
PositionEntity(Origine,0,0,0) 
EntityColor(Origine,255,000,000)
EntityFX(Origine,1) 

GroundMesh = CreateCube()
ScaleMesh(GroundMesh,64.0/2,0.1/2,64.0/2)
PositionMesh(GroundMesh,64.0/2,-0.1/2,64.0/2)
EntityColor(GroundMesh,000,125,000)
EntityType(GroundMesh,CollLevel%)

RockXMesh = CreateSphere(8)
ScaleMesh(RockXMesh,1.0/2,1.0/2,1.0/2)
PositionEntity(RockXMesh,0,0,0)
EntityColor(RockXMesh,050,050,050)
HideEntity(RockXMesh)

For RId% = 1 To 10
 RockCopy = CopyEntity(RockXMesh)
 ScaleEntity(RockCopy,Rnd(1.0,3.0),Rnd(1.0,3.0),Rnd(1.0,3.0))
 PositionEntity(RockCopy,Rnd(3.0,61.0),0,Rnd(3.0,61.0))
 RotateEntity(RockCopy,Rnd(-180,180),Rnd(-180,180),0)
 EntityType(RockCopy,CollLevel%)
Next

CrateXMesh = CreateCube()
ScaleMesh(CrateXMesh,1.0/2,1.0/2,1.0/2)
PositionMesh(CrateXMesh,0,1.0/2,0)
PositionEntity(CrateXMesh,0,0,0)
EntityColor(CrateXMesh,125,063,050)
HideEntity(CrateXMesh)

For CId% = 1 To 10
 CrateCopy = CopyEntity(CrateXMesh)
 PositionEntity(CrateCopy,Rnd(3.0,61.0),0,Rnd(3.0,61.0))
 RotateEntity(CrateCopy,0,Rnd(-180,180),0)
 EntityType(CrateCopy,CollLevel%)
Next

PlayerCollider = CreatePivot()  
PositionEntity(PlayerCollider,0,0,0)  
EntityRadius(PlayerCollider,0.25)
EntityType(PlayerCollider,CollPlayer%)
  
PlayerColliderMarqueur = CreateSphere(16) ;for debug only
ScaleMesh(PlayerColliderMarqueur,0.5/2,0.5/2,0.5/2)
PositionEntity(PlayerColliderMarqueur,EntityX(PlayerCollider,True),EntityY(PlayerCollider,True),EntityZ(PlayerCollider,True))
EntityParent(PlayerColliderMarqueur,PlayerCollider,True)
EntityColor(PlayerColliderMarqueur,255,255,255)
EntityAlpha(PlayerColliderMarqueur,0.25)

PlayerEyes = CreatePivot()
PositionEntity(PlayerEyes,EntityX(PlayerCollider,True),EntityY(PlayerCollider,True)+1.6-0.25,EntityZ(PlayerCollider,True)+0.25)
EntityParent(PlayerEyes,PlayerCollider,True)

PlayerEyesMarqueur = CreateCube() ;for debug only
ScaleMesh(PlayerEyesMarqueur,0.025/2,0.025/2,0.025/2)
PositionEntity(PlayerEyesMarqueur,EntityX(PlayerEyes,True),EntityY(PlayerEyes,True),EntityZ(PlayerEyes,True))
EntityParent(PlayerEyesMarqueur,PlayerEyes,True)
EntityColor(PlayerEyesMarqueur,000,000,255)

PlayerMesh = CreateCube()  
ScaleMesh(PlayerMesh,0.5/2,1.7/2,0.25/2)  
PositionMesh(PlayerMesh,0,1.7/2,0)  
EntityColor(PlayerMesh,000,000,125)  
PositionEntity(PlayerMesh,EntityX(PlayerCollider,True),EntityY(PlayerCollider,True)-0.25,EntityZ(PlayerCollider,True))  
EntityParent(PlayerMesh,PlayerCollider,True)  

EntityParent(Camera,0)
PositionEntity(Camera,EntityX#(PlayerEyes,True),EntityY#(PlayerEyes,True),EntityZ#(PlayerEyes,True))
RotateEntity(Camera,EntityPitch#(PlayerEyes,True),EntityYaw#(PlayerEyes,True),EntityRoll#(PlayerEyes,True))
EntityParent(Camera,PlayerEyes,True)	
CameraMode% = FirstPerson%

PositionEntity(PlayerCollider,5,0.25+0.01,5)

DirectLight = CreateLight(1)  
LightColor(DirectLight,125,125,125)  
PositionEntity(DirectLight,0,128.0,-128.0)  
RotateEntity(DirectLight,45,0,0)  
AmbientLight(063,063,063)

Collisions(CollPlayer%,CollLevel%,2,3)

Repeat  
  
 Cls()  
 
 MXSpeed# = MouseXSpeed()  
 MYSpeed# = MouseYSpeed()   
 MoveMouse(GWidth%/2,GHeight%/2)  
 PlayerEyesPitch# = PlayerEyesPitch#+MYSpeed#*0.1 
 If(PlayerEyesPitch# > 89)
  PlayerEyesPitch# = 89
 EndIf
 If(PlayerEyesPitch# < -89)
  PlayerEyesPitch# = -89
 EndIf
 PlayerYaw# = PlayerYaw#-MXSpeed#*0.1   
 RotateEntity(PlayerEyes,PlayerEyesPitch#,0,0)
 RotateEntity(PlayerCollider,0,PlayerYaw#,0)   
 
 PlayerOnGround% = EntityCollided(PlayerCollider,CollLevel%)

 If(PlayerOnGround% = 0)
  PlayerVY# = PlayerVY# - 0.0025
  TranslateEntity(PlayerCollider,0,PlayerVY#,0)  
 ElseIf(PlayerOnGround% <> 0)
  PlayerVY# = 0    
  If(KeyDown(57)=True)
   PlayerVY# = 0.1
  EndIf   
 EndIf 

 If(KeyDown(17)=True) 
  MoveEntity(PlayerCollider,0,0,0.1)  
 EndIf  
 If(KeyDown(31)=True)  
  MoveEntity(PlayerCollider,0,0,-0.1)  
 EndIf  
 If(KeyDown(30)=True)  
  MoveEntity(PlayerCollider,-0.1,0,0)  
 EndIf  
 If(KeyDown(32)=True)  
  MoveEntity(PlayerCollider,0.1,0,0)  
 EndIf

 If(KeyHit(15)=True)
  If(CameraMode% = FirstPerson%)
   EntityParent(Camera,0)
   PositionEntity(Camera,EntityX#(PlayerEyes,True),EntityY#(PlayerEyes,True),EntityZ#(PlayerEyes,True))
   RotateEntity(Camera,EntityPitch#(PlayerEyes,True),EntityYaw#(PlayerEyes,True),EntityRoll#(PlayerEyes,True))
   EntityParent(Camera,PlayerEyes,True)	
   MoveEntity(Camera,0,0,-3.0)
   CameraMode% = ThirdPerson%
  ElseIf(CameraMode% = ThirdPerson%)
   EntityParent(Camera,0)
   PositionEntity(Camera,EntityX#(PlayerEyes,True),EntityY#(PlayerEyes,True),EntityZ#(PlayerEyes,True))
   RotateEntity(Camera,EntityPitch#(PlayerEyes,True),EntityYaw#(PlayerEyes,True),EntityRoll#(PlayerEyes,True))
   EntityParent(Camera,PlayerEyes,True)	
   ;MoveEntity(Camera,0,0,0.0)
   CameraMode% = FirstPerson%
  EndIf
 EndIf

 If(KeyDown(2)=True)  
  WireFrame(True)  
 Else If(KeyDown(2)=False)  
  WireFrame(False)  
 EndIf  
 
 UpdateWorld()

 RenderWorld()  
  
 Flip(True)  
  
Until(KeyDown(1)=True)  

End

