; ID: 2967
; Author: RemiD
; Date: 2012-08-02 05:38:17
; Title: deletes an array entry + reorganizes the array list
; Description: 0.12ms for a list of 1000 entities

;This code shows you how to delete an entry from an array and to reorganize the array list.
;Notice how the meshes are not deleted but rather their pointers are copied in the SwapArray and then copied again in the NewArray
;With Blitz3d "types" this is done automatically, but arrays have the advantage that any entry can be accessed directly, and also the advantage to use 2 dimensions or 3 dimensions arrays, useful in the case of parent,child,child organisation.

Global GWidth% = 800  
Global GHeight% = 600  
GColors% = 32
GMode% = 2  
Graphics3D(GWidth%,GHeight%,GColors%,GMode%) 
SetBuffer(BackBuffer()) 
HidePointer()  
SeedRnd(MilliSecs())  

Global Camera = CreateCamera()
CameraRange(Camera,0.01,1000)
PositionEntity(Camera,0,0,0)

Const On% = 1
Const Off% = 2

Const Show% = 1
Const Hide% = 2

Const IsStatic% = 1
Const IsMoving% = 2
Const IsCollided% = 3
Const IsPlanted% = 4
Const IsRebounding% = 5
Const IsDestroyed% = 6

Global ThrowingStarXMesh = CreateCube()
ScaleMesh(ThrowingStarXMesh,0.15/2,0.01/2,0.15/2)
;UpdateNormals(ThrowingStarXMesh)
HideEntity(ThrowingStarXMesh)

Global ThrowingStarXCaster = CreateCube()
ScaleMesh(ThrowingStarXCaster,0.15/2,0.01/2,0.15/2)
;UpdateNormals(ThrowingStarXCaster)
HideEntity(ThrowingStarXCaster)

Const ProjectilesMaxCount% = 1000
Dim ProjectileColliderS(ProjectilesMaxCount%)
Dim ProjectileMesh(ProjectilesMaxCount%)
Dim ProjectileCaster(ProjectilesMaxCount%)
Dim ProjectileState%(ProjectilesMaxCount%)
Dim ProjectileDisplay%(ProjectilesMaxCount%)
Global ProjectilesCount% = 0

Const SwapProjectilesMaxCount% = 1000
Dim SwapProjectileColliderS(SwapProjectilesMaxCount%)
Dim SwapProjectileMesh(SwapProjectilesMaxCount%)
Dim SwapProjectileCaster(SwapProjectilesMaxCount%)
Dim SwapProjectileState%(SwapProjectilesMaxCount%)
Dim SwapProjectileDisplay%(SwapProjectilesMaxCount%)
Global SwapProjectilesCount% = 0

For i% = 1 To 1000
 ProjectilesCount% = ProjectilesCount% + 1
 PId% = ProjectilesCount%
 ProjectileColliderS(PId%) = CreatePivot()
 PositionEntity(ProjectileColliderS(PId%),0,0,0)
 ;Debug_ProjectileColliderS = CreateSphere(16)
 ;ScaleEntity(Debug_ProjectileColliderS,0.15/2,0.15/2,0.15/2)
 ;RotateEntity(Debug_ProjectileColliderS,EntityPitch(ProjectileColliderS(PId%),True),EntityYaw(ProjectileColliderS(PId%),True),EntityRoll(ProjectileColliderS(PId%),True))
 ;PositionEntity(Debug_ProjectileColliderS,EntityX(ProjectileColliderS(PId%),True),EntityY(ProjectileColliderS(PId%),True),EntityZ(ProjectileColliderS(PId%),True))
 ;EntityParent(Debug_ProjectileColliderS,ProjectileColliderS(PId%),True) 
 ;EntityAlpha(Debug_ProjectileColliderS,0.1)
 ProjectileMesh(PId%) = CopyEntity(ThrowingStarXMesh)
 RotateEntity(ProjectileMesh(PId%),EntityPitch(ProjectileColliderS(PId%),True),EntityYaw(ProjectileColliderS(PId%),True),EntityRoll(ProjectileColliderS(PId%),True))
 PositionEntity(ProjectileMesh(PId%),EntityX(ProjectileColliderS(PId%),True),EntityY(ProjectileColliderS(PId%),True),EntityZ(ProjectileColliderS(PId%),True))
 EntityParent(ProjectileMesh(PId%),ProjectileColliderS(PId%),True)
 EntityColor(ProjectileMesh(PId%),255,255,255)
 ProjectileCaster(PId%) = CopyEntity(ThrowingStarXCaster)
 RotateEntity(ProjectileCaster(PId%),EntityPitch(ProjectileColliderS(PId%),True),EntityYaw(ProjectileColliderS(PId%),True),EntityRoll(ProjectileColliderS(PId%),True))
 PositionEntity(ProjectileCaster(PId%),EntityX(ProjectileColliderS(PId%),True),EntityY(ProjectileColliderS(PId%),True),EntityZ(ProjectileColliderS(PId%),True))
 EntityParent(ProjectileCaster(PId%),ProjectileColliderS(PId%),True)
 EntityAlpha(ProjectileCaster(PId%),0)
 RotateEntity(ProjectileColliderS(PId%),Rnd(-180,180),Rnd(-180,180),0)
 PositionEntity(ProjectileColliderS(PId%),Rnd(0.5,19.5),1.6,Rnd(0.5,19.5))
 ProjectileState%(PId%) = IsStatic%
 ProjectileDisplay%(PId%) = On%
Next

PositionEntity(Camera,10,10,-10)
RotateEntity(Camera,22.5,0,0)

Repeat
 
 Cls()

 If(KeyHit(57)=True)
  ;Deletes the Projectile
  Print("ProjectilesCount% before = "+ProjectilesCount%)
  If(ProjectilesCount% > 0)
   PId% = Rand(1,ProjectilesCount%)
   ProjectileState%(PId%) = IsDestroyed%
   FreeEntity(ProjectileMesh(PId%))
   FreeEntity(ProjectileCaster(PId%))
   FreeEntity(ProjectileColliderS(PId%))
   ProjectileDisplay%(PId%) = Off%
   RoutineStart% = MilliSecs()
   ProjectilesReorganize()
   RoutineTime% = MilliSecs() - RoutineStart%
   Print("RoutineTime% for a list of 1000 = "+RoutineTime%)
  EndIf
  Print("ProjectilesCount% after = "+ProjectilesCount%)
  Print("Press any key to continue.")
  FlushKeys()
  WaitKey()
 EndIf

 NewTime% = MilliSecs()
 If(NewTime% >= OldTime%+3000)
  OldTime% = NewTime%
  For PId% = 1 To ProjectilesCount%
   RandomChoice% = Rand(1,2)
   If(RandomChoice% = 1)
    ProjectileDisplay%(PId%) = On%
   ElseIf(RandomChoice% = 2)
    ProjectileDisplay%(PId%) = Off%
   EndIf
  Next
 EndIf

 For PId% = 1 To ProjectilesCount%
  HideEntity(ProjectileMesh(PId%))
  If(ProjectileDisplay%(PId%) = On%)
   ShowEntity(ProjectileMesh(PId%))
  EndIf
 Next

 RenderWorld()

 Text(0,0,"Press Space to delete a random entry.")

 Flip(True)

Until(KeyDown(1)=True)

End

Function ProjectilesReorganize()
 ;Copies some Projectiles parameters in the SwapProjectiles array
 SwapProjectilesCount% = 0
 For PId% = 1 To ProjectilesCount%
  If(ProjectileState%(PId%) <> IsDestroyed%)
   SwapProjectilesCount% = SwapProjectilesCount% + 1
   SPId% = SwapProjectilesCount%
   SwapProjectileColliderS(SPId%) = ProjectileColliderS(PId%)
   SwapProjectileMesh(SPId%) = ProjectileMesh(PId%)
   SwapProjectileCaster(SPId%) = ProjectileCaster(PId%)
   SwapProjectileState%(SPId%) = ProjectileState%(PId%)
   SwapProjectileDisplay%(SPId%) = ProjectileDisplay%(PId%)
  EndIf
 Next
 ;Copies the SwapProjectiles parameters in the Projectiles array
 ProjectilesCount% = 0
 For SPId% = 1 To SwapProjectilesCount%
  If(SwapProjectileState%(SPId%) <> IsDestroyed%)
   ProjectilesCount% = ProjectilesCount% + 1
   PId% = ProjectilesCount%
   ProjectileColliderS(PId%) = SwapProjectileColliderS(SPId%)
   ProjectileMesh(PId%) = SwapProjectileMesh(SPId%)
   ProjectileCaster(PId%) = SwapProjectileCaster(SPId%)
   ProjectileState%(PId%) = SwapProjectileState%(SPId%)
   ProjectileDisplay%(PId%) = SwapProjectileDisplay%(SPId%)
  EndIf
 Next
 ;Deletes the SwapProjectiles parameters in the SwapProjectiles array
 For SPId% = 1 To SwapProjectilesCount%
  SwapProjectileColliderS(SPId%) = 0
  SwapProjectileMesh(SPId%) = 0
  SwapProjectileCaster(SPId%) = 0
  SwapProjectileState%(SPId%) = 0
  SwapProjectileDisplay%(SPId%) = 0
 Next
 SwapProjectilesCount% = 0
End Function

