' ID: 3125
' Author: munch
' Date: 2014-05-14 23:41:19
' Title: Openb3d library wrapper
' Description: Openb3d is a version of Minib3d in C++

' openb3dlib.bmx

Strict

Import Brl.Glmax2d
Import Brl.GLGraphics
Import Pub.Glew
Import Brl.Bmploader
Import Brl.Jpgloader
Import Brl.Pngloader
Import Brl.Retro

' Global declarations

Global BackBufferToTex_( tex:Byte Ptr, frame:Int )
Global BufferToTex_( tex:Byte Ptr, buffer:Byte Ptr, frame:Int )
Global CameraToTex_( tex:Byte Ptr, cam:Byte Ptr, frame:Int )
Global TexToBuffer_( tex:Byte Ptr, buffer:Byte Ptr, frame:Int )
' Minib3d Only
Global MeshCullRadius_( ent:Byte Ptr, radius:Float )
' Blitz3D functions, A-Z
Global AddAnimSeq_:Int( ent:Byte Ptr, length:Int )
Global AddMesh_( mesh1:Byte Ptr, mesh2:Byte Ptr )
Global AddTriangle_:Int( surf:Byte Ptr, v0:Int, v1:Int, v2:Int )
Global AddVertex_:Int( surf:Byte Ptr, x:Float, y:Float, z:Float, u:Float, v:Float, w:Float )
Global AmbientLight( r:Float, g:Float, b:Float )
Global AntiAlias( samples:Int )
Global Animate_( ent:Byte Ptr, mode:Int, speed:Float, seq:Int, trans:Int )
Global Animating_:Int( ent:Byte Ptr )
Global AnimLength_( ent:Byte Ptr )
Global AnimSeq_:Int( ent:Byte Ptr )
Global AnimTime_:Float( ent:Byte Ptr )
Global BrushAlpha_( brush:Byte Ptr, a:Float )
Global BrushBlend_( brush:Byte Ptr, blend:Int )
Global BrushColor_( brush:Byte Ptr, r:Float, g:Float, b:Float )
Global BrushFX_( brush:Byte Ptr, fx:Int )
Global BrushShininess_( brush:Byte Ptr, s:Float )
Global BrushTexture_( brush:Byte Ptr, tex:Byte Ptr, frame:Int, index:Int )
Global CameraClsColor_( cam:Byte Ptr, r:Float, g:Float, b:Float )
Global CameraClsMode_( cam:Byte Ptr, cls_depth:Int, cls_zbuffer:Int )
Global CameraFogColor_( cam:Byte Ptr, r:Float, g:Float, b:Float )
Global CameraFogMode_( cam:Byte Ptr, mode:Int )
Global CameraFogRange_( cam:Byte Ptr, nnear:Float, nfar:Float )
Global CameraPick_:Byte Ptr( cam:Byte Ptr, x:Float, y:Float )
Global CameraProject_( cam:Byte Ptr, x:Float, y:Float, z:Float )
Global CameraProjMode_( cam:Byte Ptr, mode:Int )
Global CameraRange_( cam:Byte Ptr, nnear:Float, nfar:Float )
Global CameraViewport_( cam:Byte Ptr, x:Int, y:Int, width:Int, height:Int )
Global CameraZoom_( cam:Byte Ptr, zoom:Float )
Global ClearSurface_( surf:Byte Ptr, clear_verts:Int, clear_tris:Int )
Global ClearTextureFilters()
Global ClearWorld_( entities:Int, brushes:Int, textures:Int )
Global CollisionEntity_:Byte Ptr( ent:Byte Ptr, index:Int )
Global Collisions_( src_no:Int, dest_no:Int, method_no:Int, response_no:Int )
Global CollisionNX_:Float( ent:Byte Ptr, index:Int )
Global CollisionNY_:Float( ent:Byte Ptr, index:Int )
Global CollisionNZ_:Float( ent:Byte Ptr, index:Int )
Global CollisionSurface_:Byte Ptr( ent:Byte Ptr, index:Int )
Global CollisionTime_:Float( ent:Byte Ptr, index:Int )
Global CollisionTriangle_:Int( ent:Byte Ptr, index:Int )
Global CollisionX_:Float( ent:Byte Ptr, index:Int )
Global CollisionY_:Float( ent:Byte Ptr, index:Int )
Global CollisionZ_:Float( ent:Byte Ptr, index:Int )
Global CountChildren_:Int( ent:Byte Ptr )
Global CountCollisions_:Int( ent:Byte Ptr )
Global CopyEntity_:Byte Ptr( ent:Byte Ptr, parent:Byte Ptr )
Global CopyMesh_:Byte Ptr( mesh:Byte Ptr, parent:Byte Ptr )
Global CountSurfaces_:Int( mesh:Byte Ptr )
Global CountTriangles_:Int( surf:Byte Ptr )
Global CountVertices_:Int( surf:Byte Ptr )
Global CreateBrush_:Byte Ptr( r:Float, g:Float, b:Float )
Global CreateCamera_:Byte Ptr( parent:Byte Ptr )
Global CreateCone_:Byte Ptr( segments:Int, solid:Int, parent:Byte Ptr )
Global CreateCylinder_:Byte Ptr( segments:Int, solid:Int, parent:Byte Ptr )
Global CreateCube_:Byte Ptr( parent:Byte Ptr )
Global CreateMesh_:Byte Ptr( parent:Byte Ptr )
Global CreateLight_:Byte Ptr( light_type:Int, parent:Byte Ptr )
Global CreatePivot_:Byte Ptr( parent:Byte Ptr )
Global CreatePlane_:Byte Ptr( divisions:Int, parent:Byte Ptr )
Global CreateShadow_:Byte Ptr( parent:Byte Ptr, Static:Int )
Global CreateSphere_:Byte Ptr( segments:Int, parent:Byte Ptr )
Global CreateSprite_:Byte Ptr( parent:Byte Ptr )
Global CreateSurface_:Byte Ptr( mesh:Byte Ptr, brush:Byte Ptr )
Global CreateStencil_:Byte Ptr()
Global CreateTerrain_:Byte Ptr( size:Int, parent:Byte Ptr )
Global CreateTexture_:Byte Ptr( width:Int, height:Int, flags:Int, frames:Int )
Global CreateVoxelSprite_:Byte Ptr( slices:Int, parent:Byte Ptr )
Global DeltaPitch_:Float( ent1:Byte Ptr, ent2:Byte Ptr )
Global DeltaYaw_:Float( ent1:Byte Ptr, ent2:Byte Ptr )
Global EntityAlpha_( ent:Byte Ptr, alpha:Float )
Global EntityAutoFade_( ent:Byte Ptr, near:Float, far:Float )
Global EntityBlend_( ent:Byte Ptr, blend:Int )
Global EntityBox_( ent:Byte Ptr, x:Float, y:Float, z:Float, w:Float, h:Float, d:Float )
Global EntityClass_:Byte Ptr( ent:Byte Ptr )
Global EntityCollided_:Byte Ptr( ent:Byte Ptr, type_no:Int )
Global EntityColor_( ent:Byte Ptr, red:Float, green:Float, blue:Float )
Global EntityDistance_:Float( ent1:Byte Ptr, ent2:Byte Ptr )
Global EntityFX_( ent:Byte Ptr, fx:Int )
Global EntityInView_:Int( ent:Byte Ptr, cam:Byte Ptr )
Global EntityName_:Byte Ptr( ent:Byte Ptr )
Global EntityOrder_( ent:Byte Ptr, order:Int )
Global EntityParent_( ent:Byte Ptr, parent_ent:Byte Ptr, glob:Int )
Global EntityPick_:Byte Ptr( ent:Byte Ptr, range:Float )
Global EntityPickMode_( ent:Byte Ptr, pick_mode:Int, obscurer:Int )
Global EntityPitch_:Float( ent:Byte Ptr, glob:Int )
Global EntityRadius_( ent:Byte Ptr, radius_x:Float, radius_y:Float )
Global EntityRoll_:Float( ent:Byte Ptr, glob:Int )
Global EntityShininess_( ent:Byte Ptr, shine:Float )
Global EntityTexture_( ent:Byte Ptr, tex:Byte Ptr, frame:Int, index:Int )
Global EntityType_( ent:Byte Ptr, type_no:Int, recursive:Int )
Global EntityVisible_:Int( src_ent:Byte Ptr, dest_ent:Byte Ptr )
Global EntityX_:Float( ent:Byte Ptr, glob:Int )
Global EntityY_:Float( ent:Byte Ptr, glob:Int )
Global EntityYaw_:Float( ent:Byte Ptr, glob:Int )
Global EntityZ_:Float( ent:Byte Ptr, glob:Int )
Global ExtractAnimSeq_:Int( ent:Byte Ptr, first_frame:Int, last_frame:Int, seq:Int )
Global FindChild_:Byte Ptr( ent:Byte Ptr, child_name:Byte Ptr )
Global FindSurface_:Byte Ptr( mesh:Byte Ptr, brush:Byte Ptr )
Global FitMesh_( mesh:Byte Ptr, x:Float, y:Float, z:Float, width:Float, height:Float, depth:Float, uniform:Int )
Global FlipMesh_( mesh:Byte Ptr )
Global FreeBrush_( brush:Byte Ptr )
Global FreeEntity_( ent:Byte Ptr )
Global FreeShadow_( shad:Byte Ptr, Static:Int )
Global FreeTexture_( tex:Byte Ptr )
Global GetBrushTexture_:Byte Ptr( brush:Byte Ptr, index:Int )
Global GetChild_:Byte Ptr( ent:Byte Ptr, child_no:Int )
Global GetEntityBrush_:Byte Ptr( ent:Byte Ptr )
Global GetEntityType_:Int( ent:Byte Ptr )
Global GetMatElement_:Float( ent:Byte Ptr, row:Int, col:Int )
Global GetParentEntity_:Byte Ptr( ent:Byte Ptr )
Global GetSurface_:Byte Ptr( mesh:Byte Ptr, surf_no:Int )
Global GetSurfaceBrush_:Byte Ptr( surf:Byte Ptr )	
Global Graphics3D_( width:Int, height:Int, depth:Int, mode:Int, rate:Int )
Global HandleSprite_( sprite:Byte Ptr, h_x:Float, h_y:Float )
Global HideEntity_( ent:Byte Ptr )
Global LightColor_( light:Byte Ptr, red:Float, green:Float, blue:Float )
Global LightConeAngles_( light:Byte Ptr, inner_ang:Float, outer_ang:Float )
Global LightRange_( light:Byte Ptr, range:Float )
Global LinePick_:Byte Ptr( x:Float, y:Float, z:Float, dx:Float, dy:Float, dz:Float, radius:Float )
Global LoadAnimMesh_:Byte Ptr( file:Byte Ptr, parent:Byte Ptr )
Global LoadAnimTexture_:Byte Ptr( file:Byte Ptr, flags:Int, frame_width:Int, frame_height:Int, first_frame:Int, frame_count:Int )
Global LoadBrush_:Byte Ptr( file:Byte Ptr, flags:Int, u_scale:Float, v_scale:Float )
Global LoadMesh_:Byte Ptr( file:Byte Ptr, parent:Byte Ptr )
Global LoadTerrain_:Byte Ptr( file:Byte Ptr, parent:Byte Ptr )
Global LoadTexture_:Byte Ptr( file:Byte Ptr, flags:Int )
Global LoadSprite_:Byte Ptr( tex_file:Byte Ptr, tex_flag:Int, parent:Byte Ptr )
Global MeshCSG_:Byte Ptr( m1:Byte Ptr, m2:Byte Ptr, method_no:Int )
Global MeshDepth_:Float( mesh:Byte Ptr )
Global MeshesIntersect_:Int( mesh1:Byte Ptr, mesh2:Byte Ptr )
Global MeshHeight_:Float( mesh:Byte Ptr )
Global MeshWidth_:Float( mesh:Byte Ptr )
Global ModifyTerrain_( terr:Byte Ptr, x:Int, z:Int, new_height:Float )
Global MoveEntity_( ent:Byte Ptr, x:Float, y:Float, z:Float )
Global NameEntity_( ent:Byte Ptr, name:Byte Ptr )
Global PaintEntity_( ent:Byte Ptr, brush:Byte Ptr )
Global PaintMesh_( mesh:Byte Ptr, brush:Byte Ptr )
Global PaintSurface_( surf:Byte Ptr, brush:Byte Ptr )
Global PickedEntity_:Byte Ptr()
Global PickedNX:Float()
Global PickedNY:Float()
Global PickedNZ:Float()
Global PickedSurface_:Byte Ptr()
Global PickedTime:Float()
Global PickedTriangle:Int()
Global PickedX:Float()
Global PickedY:Float()
Global PickedZ:Float()
Global PointEntity_( ent:Byte Ptr, target_ent:Byte Ptr, roll:Float )
Global PositionEntity_( ent:Byte Ptr, x:Float, y:Float, z:Float, glob:Int )
Global PositionMesh_( mesh:Byte Ptr, px:Float, py:Float, pz:Float )
Global PositionTexture_( tex:Byte Ptr, u_pos:Float, v_pos:Float )
Global ProjectedX:Float()
Global ProjectedY:Float()
Global ProjectedZ:Float()
Global RenderWorld()
Global RepeatMesh_:Byte Ptr( mesh:Byte Ptr, parent:Byte Ptr )
Global ResetEntity_( ent:Byte Ptr )
Global RotateEntity_( ent:Byte Ptr, x:Float, y:Float, z:Float, glob:Int )
Global RotateMesh_( mesh:Byte Ptr, pitch:Float, yaw:Float, roll:Float )
Global RotateSprite_( sprite:Byte Ptr, ang:Float )
Global RotateTexture_( tex:Byte Ptr, ang:Float )
Global ScaleEntity_( ent:Byte Ptr, x:Float, y:Float, z:Float, glob:Int )
Global ScaleMesh_( mesh:Byte Ptr, sx:Float, sy:Float, sz:Float )
Global ScaleSprite_( sprite:Byte Ptr, s_x:Float, s_y:Float )
Global ScaleTexture_( tex:Byte Ptr, u_scale:Float, v_scale:Float )
Global SetAnimTime_( ent:Byte Ptr, time:Float, seq:Int )
Global SetCubeFace_( tex:Byte Ptr, face:Int )
Global SetCubeMode_( tex:Byte Ptr, mode:Int )
Global ShowEntity_( ent:Byte Ptr )
Global SpriteViewMode_( sprite:Byte Ptr, mode:Int )
Global StencilAlpha_( stencil:Byte Ptr, a:Float )
Global StencilClsColor_( stencil:Byte Ptr, r:Float, g:Float, b:Float )
Global StencilClsMode_( stencil:Byte Ptr, cls_depth:Int, cls_zbuffer:Int )
Global StencilMesh_( stencil:Byte Ptr, mesh:Byte Ptr, mode:Int )
Global StencilMode_( stencil:Byte Ptr, m:Int )
Global TerrainHeight_:Float( terr:Byte Ptr, x:Int, z:Int )
Global TerrainX_:Float( terr:Byte Ptr, x:Float, y:Float, z:Float )
Global TerrainY_:Float( terr:Byte Ptr, x:Float, y:Float, z:Float )
Global TerrainZ_:Float( terr:Byte Ptr, x:Float, y:Float, z:Float )
Global TextureBlend_( tex:Byte Ptr, blend:Int )
Global TextureCoords_( tex:Byte Ptr, coords:Int )
Global TextureHeight_:Int( tex:Byte Ptr )
Global TextureFilter_( match_text:Byte Ptr, flags:Int )
Global TextureName_:Byte Ptr( tex:Byte Ptr )
Global TextureWidth_:Int( tex:Byte Ptr )
Global TFormedX:Float()
Global TFormedY:Float()
Global TFormedZ:Float()
Global TFormNormal_( x:Float, y:Float, z:Float, src_ent:Byte Ptr, dest_ent:Byte Ptr )
Global TFormPoint_( x:Float, y:Float, z:Float, src_ent:Byte Ptr, dest_ent:Byte Ptr )
Global TFormVector_( x:Float, y:Float, z:Float, src_ent:Byte Ptr, dest_ent:Byte Ptr )
Global TranslateEntity_( ent:Byte Ptr, x:Float, y:Float, z:Float, glob:Int )
Global TriangleVertex_:Int( surf:Byte Ptr, tri_no:Int, corner:Int )
Global TurnEntity_( ent:Byte Ptr, x:Float, y:Float, z:Float, glob:Int )
Global UpdateNormals_( mesh:Byte Ptr )
Global UpdateTexCoords_( surf:Byte Ptr )
Global UpdateWorld_( anim_speed:Float )
Global UseStencil_( stencil:Byte Ptr )
Global VectorPitch:Float( vx:Float, vy:Float, vz:Float )
Global VectorYaw:Float( vx:Float, vy:Float, vz:Float )
Global VertexAlpha_:Float( surf:Byte Ptr, vid:Int )
Global VertexBlue_:Float( surf:Byte Ptr, vid:Int )
Global VertexColor_( surf:Byte Ptr, vid:Int, r:Float, g:Float, b:Float, a:Float )
Global VertexCoords_( surf:Byte Ptr, vid:Int, x:Float, y:Float, z:Float )
Global VertexGreen_:Float( surf:Byte Ptr, vid:Int )
Global VertexNormal_( surf:Byte Ptr, vid:Int, nx:Float, nz:Float )
Global VertexNX_:Float( surf:Byte Ptr, vid:Int )
Global VertexNY_:Float( surf:Byte Ptr, vid:Int )
Global VertexNZ_:Float( surf:Byte Ptr, vid:Int )
Global VertexRed_:Float( surf:Byte Ptr, vid:Int )
Global VertexTexCoords_( surf:Byte Ptr, vid:Int, u:Float, v:Float, w:Float, coord_set:Int )
Global VertexU_:Float( surf:Byte Ptr, vid:Int, coord_set:Int )
Global VertexV_:Float( surf:Byte Ptr, vid:Int, coord_set:Int )
Global VertexW_:Float( surf:Byte Ptr, vid:Int, coord_set:Int )
Global VertexX_:Float( surf:Byte Ptr, vid:Int )
Global VertexY_:Float( surf:Byte Ptr, vid:Int )
Global VertexZ_:Float( surf:Byte Ptr, vid:Int )
Global VoxelSpriteMaterial_( voxelspr:Byte Ptr, mat:Byte Ptr )
Global Wireframe( enable:Int )
' ***extras***
Global EntityScaleX_:Float( ent:Byte Ptr, glob:Int )
Global EntityScaleY_:Float( ent:Byte Ptr, glob:Int )
Global EntityScaleZ_:Float( ent:Byte Ptr, glob:Int )
Global LoadShader_:Byte Ptr( ShaderName:Byte Ptr, VshaderFileName:Byte Ptr, FshaderFileName:Byte Ptr )
Global CreateShader_:Byte Ptr( ShaderName:Byte Ptr, VshaderString:Byte Ptr, FshaderString:Byte Ptr )
Global ShadeSurface_( surf:Byte Ptr, material:Byte Ptr )
Global ShadeMesh_( mesh:Byte Ptr, material:Byte Ptr )
Global ShadeEntity_( ent:Byte Ptr, material:Byte Ptr )
Global ShaderTexture_( material:Byte Ptr, tex:Byte Ptr, name:Byte Ptr, index:Int )
Global SetFloat_( material:Byte Ptr, name:Byte Ptr, v1:Float )
Global SetFloat2_( material:Byte Ptr, name:Byte Ptr, v1:Float, v2:Float )
Global SetFloat3_( material:Byte Ptr, name:Byte Ptr, v1:Float, v2:Float, v3:Float )
Global SetFloat4_( material:Byte Ptr, name:Byte Ptr, v1:Float, v2:Float, v3:Float, v4:Float )
Global UseFloat_( material:Byte Ptr, name:Byte Ptr, v1:Float Ptr )
Global UseFloat2_( material:Byte Ptr, name:Byte Ptr, v1:Float Ptr, v2:Float Ptr )
Global UseFloat3_( material:Byte Ptr, name:Byte Ptr, v1:Float Ptr, v2:Float Ptr, v3:Float Ptr )
Global UseFloat4_( material:Byte Ptr, name:Byte Ptr, v1:Float Ptr, v2:Float Ptr, v3:Float Ptr, v4:Float Ptr )
Global SetInteger_( material:Byte Ptr, name:Byte Ptr, v1:Int )
Global SetInteger2_( material:Byte Ptr, name:Byte Ptr, v1:Int, v2:Int )
Global SetInteger3_( material:Byte Ptr, name:Byte Ptr, v1:Int, v2:Int, v3:Int )
Global SetInteger4_( material:Byte Ptr, name:Byte Ptr, v1:Int, v2:Int, v3:Int, v4:Int )
Global UseInteger_( material:Byte Ptr, name:Byte Ptr, v1:Int Ptr )
Global UseInteger2_( material:Byte Ptr, name:Byte Ptr, v1:Int Ptr, v2:Int Ptr )
Global UseInteger3_( material:Byte Ptr, name:Byte Ptr, v1:Int Ptr, v2:Int Ptr, v3:Int Ptr )
Global UseInteger4_( material:Byte Ptr, name:Byte Ptr, v1:Int Ptr, v2:Int Ptr, v3:Int Ptr, v4:Int Ptr )
Global UseSurface_( material:Byte Ptr, name:Byte Ptr, surf:Byte Ptr, vbo:Int )
Global UseMatrix_( material:Byte Ptr, name:Byte Ptr, mode:Int )
Global LoadMaterial_:Byte Ptr( filename:Byte Ptr, flags:Int, frame_width:Int, frame_height:Int, first_frame:Int, frame_count:Int )
Global ShaderMaterial_( material:Byte Ptr, tex:Byte Ptr, name:Byte Ptr, index:Int )
Global CreateOcTree_:Byte Ptr( w:Float, h:Float, d:Float, parent_ent:Byte Ptr )
Global OctreeBlock_( octree:Byte Ptr, mesh:Byte Ptr, level:Int, X:Float, Y:Float, Z:Float, Near:Float, Far:Float )
Global OctreeMesh_( octree:Byte Ptr, mesh:Byte Ptr, level:Int, X:Float, Y:Float, Z:Float, Near:Float, Far:Float )

Private

Global obDllDirs$[] = ["" , CurrentDir()+"/" , "BlitzMax/mod/angros.mod/openb3d.mod/"]
Global obLib

Public

?Win32
Extern "win32"
	Function LoadLibraryA( dll$z )
	Function GetProcAddress:Byte Ptr( libhandle,func$z )
End Extern
?Not Win32
Extern
	Function dlopen( path$z,mode )
	Function dlsym:Byte Ptr( dl,sym$z )
	Function dlclose( dl )
End Extern
?

Function obProc:Byte Ptr( t$ )
	Local p:Byte Ptr
?Win32
	p=GetProcAddress( obLib,t )
?Not Win32
	p=dlsym( obLib,t )
?
	If p Return p
	Print "Error: Can't find symbol:"+t
	End
End Function

Function OpenLibrary()
	If obLib Return
	Local lib:String
		
	For Local path:String = EachIn obDllDirs
		lib = path
		?Win32
			obLib=LoadLibraryA( "openb3d.dll")
		?Macos
			obLib = dlopen( "libopenb3d.dylib", 1 ) 
		?Linux
			obLib = dlopen( "libOpenB3D.so", 1 )
		?
		
		If Not obLib Then
			?Win32
				lib:+ "openb3d.dll"
				obLib=LoadLibraryA( lib )
			?Macos
				lib:+ "libopenb3d.dylib"
				obLib=dlopen( lib,1 )
			?Linux
				lib:+ "libOpenB3D.so"
				obLib = dlopen( lib , 1 ) 
			?
		EndIf
		If obLib Then Exit
	Next
	
	If Not obLib
		Print "Error: Can't open lib:"+lib
		End
	EndIf
	
	' Function pointers
	BackBufferToTex_=obProc("BackBufferToTex")
	BufferToTex_=obProc("BufferToTex")
	CameraToTex_=obProc("CameraToTex")
	TexToBuffer_=obProc("TexToBuffer")
	' Minib3d Only
	MeshCullRadius_=obProc("MeshCullRadius")
	' Blitz3D functions, A-Z
	AddAnimSeq_=obProc("AddAnimSeq")
	AddMesh_=obProc("AddMesh")
	AddTriangle_=obProc("AddTriangle")
	AddVertex_=obProc("AddVertex")
	AmbientLight=obProc("AmbientLight")
	AntiAlias=obProc("AntiAlias")
	Animate_=obProc("Animate")
	Animating_=obProc("Animating")
	AnimLength_=obProc("AnimLength")
	AnimSeq_=obProc("AnimSeq")
	AnimTime_=obProc("AnimTime")
	BrushAlpha_=obProc("BrushAlpha")
	BrushBlend_=obProc("BrushBlend")
	BrushColor_=obProc("BrushColor")
	BrushFX_=obProc("BrushFX")
	BrushShininess_=obProc("BrushShininess")
	BrushTexture_=obProc("BrushTexture")
	CameraClsColor_=obProc("CameraClsColor")
	CameraClsMode_=obProc("CameraClsMode")
	CameraFogColor_=obProc("CameraFogColor")
	CameraFogMode_=obProc("CameraFogMode")
	CameraFogRange_=obProc("CameraFogRange")
	CameraPick_=obProc("CameraPick")
	CameraProject_=obProc("CameraProject")
	CameraProjMode_=obProc("CameraProjMode")
	CameraRange_=obProc("CameraRange")
	CameraViewport_=obProc("CameraViewport")
	CameraZoom_=obProc("CameraZoom")
	ClearSurface_=obProc("ClearSurface")
	ClearTextureFilters=obProc("ClearTextureFilters")
	ClearWorld_=obProc("ClearWorld")
	CollisionEntity_=obProc("CollisionEntity")
	Collisions_=obProc("Collisions")
	CollisionNX_=obProc("CollisionNX")
	CollisionNY_=obProc("CollisionNY")
	CollisionNZ_=obProc("CollisionNZ")
	CollisionSurface_=obProc("CollisionSurface")
	CollisionTime_=obProc("CollisionTime")
	CollisionTriangle_=obProc("CollisionTriangle")
	CollisionX_=obProc("CollisionX")
	CollisionY_=obProc("CollisionY")
	CollisionZ_=obProc("CollisionZ")
	CountChildren_=obProc("CountChildren")
	CountCollisions_=obProc("CountCollisions")
	CopyEntity_=obProc("CopyEntity")
	CopyMesh_=obProc("CopyMesh")
	CountSurfaces_=obProc("CountSurfaces")
	CountTriangles_=obProc("CountTriangles")
	CountVertices_=obProc("CountVertices")
	CreateBrush_=obProc("CreateBrush")
	CreateCamera_=obProc("CreateCamera")
	CreateCone_=obProc("CreateCone")
	CreateCylinder_=obProc("CreateCylinder")
	CreateCube_=obProc("CreateCube")
	CreateMesh_=obProc("CreateMesh")
	CreateLight_=obProc("CreateLight")
	CreatePivot_=obProc("CreatePivot")
	CreatePlane_=obProc("CreatePlane")
	CreateShadow_=obProc("CreateShadow")
	CreateSphere_=obProc("CreateSphere")
	CreateSprite_=obProc("CreateSprite")
	CreateSurface_=obProc("CreateSurface")
	CreateStencil_=obProc("CreateStencil")
	CreateTerrain_=obProc("CreateTerrain")
	CreateTexture_=obProc("CreateTexture")
	CreateVoxelSprite_=obProc("CreateVoxelSprite")
	DeltaPitch_=obProc("DeltaPitch")
	DeltaYaw_=obProc("DeltaYaw")
	EntityAlpha_=obProc("EntityAlpha")
	EntityAutoFade_=obProc("EntityAutoFade")
	EntityBlend_=obProc("EntityBlend")
	EntityBox_=obProc("EntityBox")
	EntityClass_=obProc("EntityClass")
	EntityCollided_=obProc("EntityCollided")
	EntityColor_=obProc("EntityColor")
	EntityDistance_=obProc("EntityDistance")
	EntityFX_=obProc("EntityFX")
	EntityInView_=obProc("EntityInView")
	EntityName_=obProc("EntityName")
	EntityOrder_=obProc("EntityOrder")
	EntityParent_=obProc("EntityParent")
	EntityPick_=obProc("EntityPick")
	EntityPickMode_=obProc("EntityPickMode")
	EntityPitch_=obProc("EntityPitch")
	EntityRadius_=obProc("EntityRadius")
	EntityRoll_=obProc("EntityRoll")
	EntityShininess_=obProc("EntityShininess")
	EntityTexture_=obProc("EntityTexture")
	EntityType_=obProc("EntityType")
	EntityVisible_=obProc("EntityVisible")
	EntityX_=obProc("EntityX")
	EntityY_=obProc("EntityY")
	EntityYaw_=obProc("EntityYaw")
	EntityZ_=obProc("EntityZ")
	ExtractAnimSeq_=obProc("ExtractAnimSeq")
	FindChild_=obProc("FindChild")
	FindSurface_=obProc("FindSurface")
	FitMesh_=obProc("FitMesh")
	FlipMesh_=obProc("FlipMesh")
	FreeBrush_=obProc("FreeBrush")
	FreeEntity_=obProc("FreeEntity")
	FreeShadow_=obProc("FreeShadow")
	FreeTexture_=obProc("FreeTexture")
	GetBrushTexture_=obProc("GetBrushTexture")
	GetChild_=obProc("GetChild")
	GetEntityBrush_=obProc("GetEntityBrush")
	GetEntityType_=obProc("GetEntityType")
	GetMatElement_=obProc("GetMatElement")
	GetParentEntity_=obProc("GetParentEntity")
	GetSurface_=obProc("GetSurface")
	GetSurfaceBrush_=obProc("GetSurfaceBrush")
	Graphics3D_=obProc("Graphics3D")
	HandleSprite_=obProc("HandleSprite")
	HideEntity_=obProc("HideEntity")
	LightColor_=obProc("LightColor")
	LightConeAngles_=obProc("LightConeAngles")
	LightRange_=obProc("LightRange")
	LinePick_=obProc("LinePick")
	LoadAnimMesh_=obProc("LoadAnimMesh")
	LoadAnimTexture_=obProc("LoadAnimTexture")
	LoadBrush_=obProc("LoadBrush")
	LoadMesh_=obProc("LoadMesh")
	LoadTerrain_=obProc("LoadTerrain")
	LoadTexture_=obProc("LoadTexture")
	LoadSprite_=obProc("LoadSprite")
	MeshCSG_=obProc("MeshCSG")
	MeshDepth_=obProc("MeshDepth")
	MeshesIntersect_=obProc("MeshesIntersect")
	MeshHeight_=obProc("MeshHeight")
	MeshWidth_=obProc("MeshWidth")
	ModifyTerrain_=obProc("ModifyTerrain")
	MoveEntity_=obProc("MoveEntity")
	NameEntity_=obProc("NameEntity")
	PaintEntity_=obProc("PaintEntity")
	PaintMesh_=obProc("PaintMesh")
	PaintSurface_=obProc("PaintSurface")
	PickedEntity_=obProc("PickedEntity")
	PickedNX=obProc("PickedNX")
	PickedNY=obProc("PickedNY")
	PickedNZ=obProc("PickedNZ")
	PickedSurface_=obProc("PickedSurface")
	PickedTime=obProc("PickedTime")
	PickedTriangle=obProc("PickedTriangle")
	PickedX=obProc("PickedX")
	PickedY=obProc("PickedY")
	PickedZ=obProc("PickedZ")
	PointEntity_=obProc("PointEntity")
	PositionEntity_=obProc("PositionEntity")
	PositionMesh_=obProc("PositionMesh")
	PositionTexture_=obProc("PositionTexture")
	ProjectedX=obProc("ProjectedX")
	ProjectedY=obProc("ProjectedY")
	ProjectedZ=obProc("ProjectedZ")
	RenderWorld=obProc("RenderWorld")
	RepeatMesh_=obProc("RepeatMesh")
	ResetEntity_=obProc("ResetEntity")
	RotateEntity_=obProc("RotateEntity")
	RotateMesh_=obProc("RotateMesh")
	RotateSprite_=obProc("RotateSprite")
	RotateTexture_=obProc("RotateTexture")
	ScaleEntity_=obProc("ScaleEntity")
	ScaleMesh_=obProc("ScaleMesh")
	ScaleSprite_=obProc("ScaleSprite")
	ScaleTexture_=obProc("ScaleTexture")
	SetAnimTime_=obProc("SetAnimTime")
	SetCubeFace_=obProc("SetCubeFace")
	SetCubeMode_=obProc("SetCubeMode")
	ShowEntity_=obProc("ShowEntity")
	SpriteViewMode_=obProc("SpriteViewMode")
	StencilAlpha_=obProc("StencilAlpha")
	StencilClsColor_=obProc("StencilClsColor")
	StencilClsMode_=obProc("StencilClsMode")
	StencilMesh_=obProc("StencilMesh")
	StencilMode_=obProc("StencilMode")
	TerrainHeight_=obProc("TerrainHeight")
	TerrainX_=obProc("TerrainX")
	TerrainY_=obProc("TerrainY")
	TerrainZ_=obProc("TerrainZ")
	TextureBlend_=obProc("TextureBlend")
	TextureCoords_=obProc("TextureCoords")
	TextureHeight_=obProc("TextureHeight")
	TextureFilter_=obProc("TextureFilter")
	TextureName_=obProc("TextureName")
	TextureWidth_=obProc("TextureWidth")
	TFormedX=obProc("TFormedX")
	TFormedY=obProc("TFormedY")
	TFormedZ=obProc("TFormedZ")
	TFormNormal_=obProc("TFormNormal")
	TFormPoint_=obProc("TFormPoint")
	TFormVector_=obProc("TFormVector")
	TranslateEntity_=obProc("TranslateEntity")
	TriangleVertex_=obProc("TriangleVertex")
	TurnEntity_=obProc("TurnEntity")
	UpdateNormals_=obProc("UpdateNormals")
	UpdateTexCoords_=obProc("UpdateTexCoords")
	UpdateWorld_=obProc("UpdateWorld")
	UseStencil_=obProc("UseStencil")
	VectorPitch=obProc("VectorPitch")
	VectorYaw=obProc("VectorYaw")
	VertexAlpha_=obProc("VertexAlpha")
	VertexBlue_=obProc("VertexBlue")
	VertexColor_=obProc("VertexColor")
	VertexCoords_=obProc("VertexCoords")
	VertexGreen_=obProc("VertexGreen")
	VertexNormal_=obProc("VertexNormal")
	VertexNX_=obProc("VertexNX")
	VertexNY_=obProc("VertexNY")
	VertexNZ_=obProc("VertexNZ")
	VertexRed_=obProc("VertexRed")
	VertexTexCoords_=obProc("VertexTexCoords")
	VertexU_=obProc("VertexU")
	VertexV_=obProc("VertexV")
	VertexW_=obProc("VertexW")
	VertexX_=obProc("VertexX")
	VertexY_=obProc("VertexY")
	VertexZ_=obProc("VertexZ")
	VoxelSpriteMaterial_=obProc("VoxelSpriteMaterial")
	Wireframe=obProc("Wireframe")
	' ***extras***
	EntityScaleX_=obProc("EntityScaleX")
	EntityScaleY_=obProc("EntityScaleY")
	EntityScaleZ_=obProc("EntityScaleZ")
	LoadShader_=obProc("LoadShader")
	CreateShader_=obProc("CreateShader")
	ShadeSurface_=obProc("ShadeSurface")
	ShadeMesh_=obProc("ShadeMesh")
	ShadeEntity_=obProc("ShadeEntity")
	ShaderTexture_=obProc("ShaderTexture")
	SetFloat_=obProc("SetFloat")
	SetFloat2_=obProc("SetFloat2")
	SetFloat3_=obProc("SetFloat3")
	SetFloat4_=obProc("SetFloat4")
	UseFloat_=obProc("UseFloat")
	UseFloat2_=obProc("UseFloat2")
	UseFloat3_=obProc("UseFloat3")
	UseFloat4_=obProc("UseFloat4")
	SetInteger_=obProc("SetInteger")
	SetInteger2_=obProc("SetInteger2")
	SetInteger3_=obProc("SetInteger3")
	SetInteger4_=obProc("SetInteger4")
	UseInteger_=obProc("UseInteger")
	UseInteger2_=obProc("UseInteger2")
	UseInteger3_=obProc("UseInteger3")
	UseInteger4_=obProc("UseInteger4")
	UseSurface_=obProc("UseSurface")
	UseMatrix_=obProc("UseMatrix")
	LoadMaterial_=obProc("LoadMaterial")
	ShaderMaterial_=obProc("ShaderMaterial")
	CreateOcTree_=obProc("CreateOcTree")
	OctreeBlock_=obProc("OctreeBlock")
	OctreeMesh_=obProc("OctreeMesh")
End Function

' todo SetBuffer version, drawtext in 3d

Function Graphics3D( width:Int, height:Int, depth:Int=0, mode:Int=0, rate:Int=60, flags:Int=..
GRAPHICS_BACKBUFFER | GRAPHICS_DEPTHBUFFER | GRAPHICS_ALPHABUFFER | GRAPHICS_STENCILBUFFER )
	OpenLibrary()
	SetGraphicsDriver( GLMax2DDriver(), flags) ' mixed 2d/3d
	Graphics( width, height, depth, rate )
	Graphics3D_( width, height, depth, mode, rate )
End Function

Function GLGraphics3D( width:Int, height:Int, depth:Int=0, mode:Int=0, rate:Int=60, flags:Int=..
GRAPHICS_BACKBUFFER | GRAPHICS_DEPTHBUFFER | GRAPHICS_ALPHABUFFER | GRAPHICS_STENCILBUFFER )
	OpenLibrary()
	GLGraphics( width, height, depth, rate, flags ) ' pure 3d
	glewInit()
	Graphics3D_( width, height, depth, mode, rate )
End Function

' Wrapped functions with Byte Ptr arguments (for casting to Int)

' Minib3d Only
Function MeshCullRadius( ent:Int, radius:Float )
	MeshCullRadius_( Byte Ptr(ent), radius )
End Function

' Blitz3D functions, A-Z
Function AddAnimSeq:Int( ent:Int, length:Int )
	Return AddAnimSeq_( Byte Ptr(ent), length )
End Function

Function AddMesh( mesh1:Int, mesh2:Int )
	AddMesh_( Byte Ptr(mesh1), Byte Ptr(mesh2) )
End Function

Function AddTriangle:Int( surf:Int, v0:Int, v1:Int, v2:Int )
	Return AddTriangle_( Byte Ptr(surf), v0, v1, v2 )
End Function

Function Animating:Int( ent:Int )
	Return Animating_( Byte Ptr(ent) )
End Function

Function AnimLength( ent:Int )
	AnimLength_( Byte Ptr(ent) )
End Function

Function AnimSeq:Int( ent:Int )
	Return AnimSeq_( Byte Ptr(ent) )
End Function

Function AnimTime:Float( ent:Int )
	Return AnimTime_( Byte Ptr(ent) )
End Function

Function BrushAlpha( brush:Int, a:Float )
	BrushAlpha_( Byte Ptr(brush), a )
End Function

Function BrushBlend( brush:Int, blend:Int )
	BrushBlend_( Byte Ptr(brush), blend )
End Function

Function BrushColor( brush:Int, r:Float, g:Float, b:Float )
	BrushColor_( Byte Ptr(brush), r, g, b )
End Function

Function BrushFX( brush:Int, fx:Int )
	BrushFX_( Byte Ptr(brush), fx )
End Function

Function BrushShininess( brush:Int, s:Float )
	BrushShininess_( Byte Ptr(brush), s )
End Function

Function CameraClsColor( cam:Int, r:Float, g:Float, b:Float )
	CameraClsColor_( Byte Ptr(cam), r, g, b )
End Function

Function CameraClsMode( cam:Int, cls_depth:Int, cls_zbuffer:Int )
	CameraClsMode_( Byte Ptr(cam), cls_depth, cls_zbuffer )
End Function

Function CameraFogColor( cam:Int, r:Float, g:Float, b:Float )
	CameraFogColor_( Byte Ptr(cam), r, g, b )
End Function

Function CameraFogMode( cam:Int, mode:Int )
	CameraFogMode_( Byte Ptr(cam), mode )
End Function

Function CameraFogRange( cam:Int, nnear:Float, nfar:Float )
	CameraFogRange_( Byte Ptr(cam), nnear, nfar )
End Function

Function CameraPick:Int( cam:Int, x:Float, y:Float )
	Return Int( CameraPick_( Byte Ptr(cam), x, y ) )
End Function

Function CameraProject( cam:Int, x:Float, y:Float, z:Float )
	CameraProject_( Byte Ptr(cam), x, y, z )
End Function

Function CameraProjMode( cam:Int, mode:Int )
	CameraProjMode_( Byte Ptr(cam), mode )
End Function

Function CameraRange( cam:Int, nnear:Float, nfar:Float )
	CameraRange_( Byte Ptr(cam), nnear, nfar )
End Function

Function CameraViewport( cam:Int, x:Int, y:Int, width:Int, height:Int )
	CameraViewport_( Byte Ptr(cam), x, y, width, height )
End Function

Function CameraZoom( cam:Int, zoom:Float )
	CameraZoom_( Byte Ptr(cam), zoom )
End Function

Function CollisionEntity:Int( ent:Int, index:Int )
	Return Int( CollisionEntity_( Byte Ptr(ent), index ) )
End Function

Function CollisionNX:Float( ent:Int, index:Int )
	Return CollisionNX_( Byte Ptr(ent), index )
End Function

Function CollisionNY:Float( ent:Int, index:Int )
	Return CollisionNY_( Byte Ptr(ent), index )
End Function

Function CollisionNZ:Float( ent:Int, index:Int )
	Return CollisionNZ_( Byte Ptr(ent), index )
End Function

Function CollisionSurface:Int( ent:Int, index:Int )
	Return Int( CollisionSurface_( Byte Ptr(ent), index ) )
End Function

Function CollisionTime:Float( ent:Int, index:Int )
	Return CollisionTime_( Byte Ptr(ent), index )
End Function

Function CollisionTriangle:Int( ent:Int, index:Int )
	Return CollisionTriangle_( Byte Ptr(ent), index )
End Function

Function CollisionX:Float( ent:Int, index:Int )
	Return CollisionX_( Byte Ptr(ent), index )
End Function

Function CollisionY:Float( ent:Int, index:Int )
	Return CollisionY_( Byte Ptr(ent), index )
End Function

Function CollisionZ:Float( ent:Int, index:Int )
	Return CollisionZ_( Byte Ptr(ent), index )
End Function

Function CountChildren:Int( ent:Int )
	Return CountChildren_( Byte Ptr(ent) )
End Function

Function CountCollisions:Int( ent:Int )
	Return CountCollisions_( Byte Ptr(ent) )
End Function

Function CountSurfaces:Int( mesh:Int )
	Return CountSurfaces_( Byte Ptr(mesh) )
End Function

Function CountTriangles:Int( surf:Int )
	Return CountTriangles_( Byte Ptr(surf) )
End Function

Function CountVertices:Int( surf:Int )
	Return CountVertices_( Byte Ptr(surf) )
End Function

Function CreateStencil:Int()
	Return Int( CreateStencil() )
End Function

Function DeltaPitch:Float( ent1:Int, ent2:Int )
	Return DeltaPitch_( Byte Ptr(ent1), Byte Ptr(ent2) )
End Function

Function DeltaYaw:Float( ent1:Int, ent2:Int )
	Return DeltaYaw_( Byte Ptr(ent1), Byte Ptr(ent2) )
End Function

Function EntityAlpha( ent:Int, alpha:Float )
	EntityAlpha_( Byte Ptr(ent), alpha )
End Function

Function EntityAutoFade( ent:Int, near:Float, far:Float )
	EntityAutoFade_( Byte Ptr(ent), near, far )
End Function

Function EntityBlend( ent:Int, blend:Int )
	EntityBlend_( Byte Ptr(ent), blend )
End Function

Function EntityBox( ent:Int, x:Float, y:Float, z:Float, w:Float, h:Float, d:Float )
	EntityBox_( Byte Ptr(ent), x, y, z, w, h, d )
End Function

Function EntityClass:String( ent:Int )
	Return String.FromCString( EntityClass_( Byte Ptr(ent) ) )
End Function

Function EntityCollided:Int( ent:Int, type_no:Int )
	Return Int( EntityCollided_( Byte Ptr(ent), type_no ) )
End Function

Function EntityColor( ent:Int, red:Float, green:Float, blue:Float )
	EntityColor_( Byte Ptr(ent), red, green, blue )
End Function

Function EntityDistance:Float( ent1:Int, ent2:Int )
	Return EntityDistance_( Byte Ptr(ent1), Byte Ptr(ent2) )
End Function

Function EntityFX( ent:Int, fx:Int )
	EntityFX_( Byte Ptr(ent), fx )
End Function

Function EntityInView:Int( ent:Int, cam:Int )
	Return EntityInView_( Byte Ptr(ent), Byte Ptr(cam) )
End Function

Function EntityName:String( ent:Int )
	Return String.FromCString( EntityName_( Byte Ptr(ent) ) )
End Function

Function EntityOrder( ent:Int, order:Int )
	EntityOrder_( Byte Ptr(ent), order )
End Function

Function EntityPick:Int( ent:Int, range:Float )
	Return Int( EntityPick_( Byte Ptr(ent), range ) )
End Function

Function EntityShininess( ent:Int, shine:Float )
	EntityShininess_( Byte Ptr(ent), shine )
End Function

Function EntityVisible:Int( src_ent:Int, dest_ent:Int )
	Return EntityVisible_( Byte Ptr(src_ent), Byte Ptr(dest_ent) )
End Function

Function FindChild:Int( ent:Int, child_name:String )
	Return Int( FindChild_( Byte Ptr(ent), child_name.ToCString() ) )
End Function

Function FindSurface:Int( mesh:Int, brush:Int )
	Return Int( FindSurface_( Byte Ptr(mesh), Byte Ptr(brush) ) )
End Function

Function FlipMesh( mesh:Int )
	FlipMesh_( Byte Ptr(mesh) )
End Function

Function FreeBrush( brush:Int )
	FreeBrush_( Byte Ptr(brush) )
End Function

Function FreeEntity( ent:Int )
	FreeEntity_( Byte Ptr(ent) )
End Function

Function FreeTexture( tex:Int )
	FreeTexture_( Byte Ptr(tex) )
End Function

Function GetChild:Int( ent:Int, child_no:Int )
	Return Int( GetChild_( Byte Ptr(ent), child_no ) )
End Function

Function GetEntityBrush:Int( ent:Int )
	Return Int( GetEntityBrush_( Byte Ptr(ent) ) )
End Function

Function GetEntityType:Int( ent:Int )
	Return GetEntityType_( Byte Ptr(ent) )
End Function

Function GetMatElement:Float( ent:Int, row:Int, col:Int )
	Return GetMatElement_( Byte Ptr(ent), row, col )
End Function

Function GetParentEntity:Int( ent:Int )
	Return Int( GetParentEntity_( Byte Ptr(ent) ) )
End Function

Function GetSurface:Int( mesh:Int, surf_no:Int )
	Return Int( GetSurface_( Byte Ptr(mesh), surf_no ) )
End Function

Function GetSurfaceBrush:Int( surf:Int )	
	Return Int( GetSurfaceBrush_( Byte Ptr(surf) ) )
End Function

Function HandleSprite( sprite:Int, h_x:Float, h_y:Float )
	HandleSprite_( Byte Ptr(sprite), h_x, h_y )
End Function

Function HideEntity( ent:Int )
	HideEntity_( Byte Ptr(ent) )
End Function

Function LightColor( light:Int, red:Float, green:Float, blue:Float )
	LightColor_( Byte Ptr(light), red, green, blue )
End Function

Function LightConeAngles( light:Int, inner_ang:Float, outer_ang:Float )
	LightConeAngles_( Byte Ptr(light), inner_ang, outer_ang )
End Function

Function LightRange( light:Int, range:Float )
	LightRange_( Byte Ptr(light), range )
End Function

Function LoadAnimTexture:Int( file:String, flags:Int, frame_width:Int, frame_height:Int, first_frame:Int, frame_count:Int )
	Return Int( LoadAnimTexture_( file.ToCString(), flags, frame_width, frame_height, first_frame, frame_count ) )
End Function

Function MeshDepth:Float( mesh:Int )
	Return MeshDepth_( Byte Ptr(mesh) )
End Function

Function MeshesIntersect:Int( mesh1:Int, mesh2:Int )
	Return MeshesIntersect_( Byte Ptr(mesh1), Byte Ptr(mesh2) )
End Function

Function MeshHeight:Float( mesh:Int )
	Return MeshHeight_( Byte Ptr(mesh) )
End Function

Function MeshWidth:Float( mesh:Int )
	Return MeshWidth_( Byte Ptr(mesh) )
End Function

Function ModifyTerrain( terr:Int, x:Int, z:Int, new_height:Float )
	ModifyTerrain_( Byte Ptr(terr), x, z, new_height )
End Function

Function MoveEntity( ent:Int, x:Float, y:Float, z:Float )
	MoveEntity_( Byte Ptr(ent), x, y, z )
End Function

Function NameEntity( ent:Int, name:String )
	NameEntity_( Byte Ptr(ent), name.ToCString() )
End Function

Function PaintEntity( ent:Int, brush:Int )
	PaintEntity_( Byte Ptr(ent), Byte Ptr(brush) )
End Function

Function PaintMesh( mesh:Int, brush:Int )
	PaintMesh_( Byte Ptr(mesh), Byte Ptr(brush) )
End Function

Function PaintSurface( surf:Int, brush:Int )
	PaintSurface_( Byte Ptr(surf), Byte Ptr(brush) )
End Function

Function PickedEntity:Int()
	Return Int( PickedEntity_() )
End Function

Function PickedSurface:Int()
	Return Int( PickedSurface_() )
End Function

Function PositionMesh( mesh:Int, px:Float, py:Float, pz:Float )
	PositionMesh_( Byte Ptr(mesh), px, py, pz )
End Function

Function PositionTexture( tex:Int, u_pos:Float, v_pos:Float )
	PositionTexture_( Byte Ptr(tex), u_pos, v_pos )
End Function

Function ResetEntity( ent:Int )
	ResetEntity_( Byte Ptr(ent) )
End Function

Function RotateMesh( mesh:Int, pitch:Float, yaw:Float, roll:Float )
	RotateMesh_( Byte Ptr(mesh), pitch, yaw, roll )
End Function

Function RotateSprite( sprite:Int, ang:Float )
	RotateSprite_( Byte Ptr(sprite), ang )
End Function

Function RotateTexture( tex:Int, ang:Float )
	RotateTexture_( Byte Ptr(tex), ang )
End Function

Function ScaleMesh( mesh:Int, sx:Float, sy:Float, sz:Float )
	ScaleMesh_( Byte Ptr(mesh), sx, sy, sz )
End Function

Function ScaleSprite( sprite:Int, s_x:Float, s_y:Float )
	ScaleSprite_( Byte Ptr(sprite), s_x, s_y )
End Function

Function ScaleTexture( tex:Int, u_scale:Float, v_scale:Float )
	ScaleTexture_( Byte Ptr(tex), u_scale, v_scale )
End Function

Function SetCubeFace( tex:Int, face:Int )
	SetCubeFace_( Byte Ptr(tex), face )
End Function

Function SetCubeMode( tex:Int, mode:Int )
	SetCubeMode_( Byte Ptr(tex), mode )
End Function

Function ShowEntity( ent:Int )
	ShowEntity_( Byte Ptr(ent) )
End Function

Function SpriteViewMode( sprite:Int, mode:Int )
	SpriteViewMode_( Byte Ptr(sprite), mode )
End Function

Function StencilAlpha( stencil:Int, a:Float )
	StencilAlpha_( Byte Ptr(stencil), a )
End Function

Function StencilClsColor( stencil:Int, r:Float, g:Float, b:Float )
	StencilClsColor_( Byte Ptr(stencil), r, g, b )
End Function

Function StencilClsMode( stencil:Int, cls_depth:Int, cls_zbuffer:Int )
	StencilClsMode_( Byte Ptr(stencil), cls_depth, cls_zbuffer )
End Function

Function StencilMode( stencil:Int, m:Int )
	StencilMode_( Byte Ptr(stencil), m )
End Function

Function TerrainHeight:Float( terr:Int, x:Int, z:Int )
	Return TerrainHeight_( Byte Ptr(terr), x, z )
End Function

Function TerrainX:Float( terr:Int, x:Float, y:Float, z:Float )
	Return TerrainX_( Byte Ptr(terr), x, y, z )
End Function

Function TerrainY:Float( terr:Int, x:Float, y:Float, z:Float )
	Return TerrainY_( Byte Ptr(terr), x, y, z )
End Function

Function TerrainZ:Float( terr:Int, x:Float, y:Float, z:Float )
	Return TerrainZ_( Byte Ptr(terr), x, y, z )
End Function

Function TextureBlend( tex:Int, blend:Int )
	TextureBlend_( Byte Ptr(tex), blend )
End Function

Function TextureCoords( tex:Int, coords:Int )
	TextureCoords_( Byte Ptr(tex), coords )
End Function

Function TextureHeight:Int( tex:Int )
	Return TextureHeight_( Byte Ptr(tex) )
End Function

Function TextureFilter( match_text:String, flags:Int )
	TextureFilter_( match_text.ToCString(), flags )
End Function

Function TextureName:String( tex:Int )
	Return String.FromCString( TextureName_( Byte Ptr(tex) ) )
End Function

Function TextureWidth:Int( tex:Int )
	Return TextureWidth_( Byte Ptr(tex) )
End Function

Function TFormNormal( x:Float, y:Float, z:Float, src_ent:Int, dest_ent:Int )
	TFormNormal_( x, y, z, Byte Ptr(src_ent), Byte Ptr(dest_ent) )
End Function

Function TFormPoint( x:Float, y:Float, z:Float, src_ent:Int, dest_ent:Int )
	TFormPoint_( x, y, z, Byte Ptr(src_ent), Byte Ptr(dest_ent) )
End Function

Function TFormVector( x:Float, y:Float, z:Float, src_ent:Int, dest_ent:Int )
	TFormVector_( x, y, z, Byte Ptr(src_ent), Byte Ptr(dest_ent) )
End Function

Function TriangleVertex:Int( surf:Int, tri_no:Int, corner:Int )
	Return TriangleVertex_( Byte Ptr(surf), tri_no, corner )
End Function

Function UpdateNormals( mesh:Int )
	UpdateNormals_( Byte Ptr(mesh) )
End Function

Function UpdateTexCoords( surf:Int )
	UpdateTexCoords_( Byte Ptr(surf) )
End Function

Function UseStencil( stencil:Int )
	UseStencil_( Byte Ptr(stencil) )
End Function

Function VertexAlpha:Float( surf:Int, vid:Int )
	Return VertexAlpha_( Byte Ptr(surf), vid )
End Function

Function VertexBlue:Float( surf:Int, vid:Int )
	Return VertexBlue_( Byte Ptr(surf), vid )
End Function

Function VertexCoords( surf:Int, vid:Int, x:Float, y:Float, z:Float )
	VertexCoords_( Byte Ptr(surf), vid, x, y, z )
End Function

Function VertexGreen:Float( surf:Int, vid:Int )
	Return VertexGreen_( Byte Ptr(surf), vid )
End Function

Function VertexNormal( surf:Int, vid:Int, nx:Float, nz:Float )
	VertexNormal_( Byte Ptr(surf), vid, nx, nz )
End Function

Function VertexNX:Float( surf:Int, vid:Int )
	Return VertexNX_( Byte Ptr(surf), vid )
End Function

Function VertexNY:Float( surf:Int, vid:Int )
	Return VertexNY_( Byte Ptr(surf), vid )
End Function

Function VertexNZ:Float( surf:Int, vid:Int )
	Return VertexNZ_( Byte Ptr(surf), vid )
End Function

Function VertexRed:Float( surf:Int, vid:Int )
	Return VertexRed_( Byte Ptr(surf), vid )
End Function

Function VertexX:Float( surf:Int, vid:Int )
	Return VertexX_( Byte Ptr(surf), vid )
End Function

Function VertexY:Float( surf:Int, vid:Int )
	Return VertexY_( Byte Ptr(surf), vid )
End Function

Function VertexZ:Float( surf:Int, vid:Int )
	Return VertexZ_( Byte Ptr(surf), vid )
End Function

Function VoxelSpriteMaterial( voxelspr:Int, mat:Int )
	VoxelSpriteMaterial_( Byte Ptr(voxelspr), Byte Ptr(mat) )
End Function

' ***extras***
Function LoadShader:Int( ShaderName:String, VshaderFileName:String, FshaderFileName:String )
	Return Int( LoadShader_( ShaderName.ToCString(), VshaderFileName.ToCString(), FshaderFileName.ToCString() ) )
End Function

Function CreateShader:Int( ShaderName:String, VshaderString:String, FshaderString:String )
	Return Int( CreateShader_( ShaderName.ToCString(), VshaderString.ToCString(), FshaderString.ToCString() ) )
End Function

Function ShadeSurface( surf:Int, material:Int )
	ShadeSurface_( Byte Ptr(surf), Byte Ptr(material) )
End Function

Function ShadeMesh( mesh:Int, material:Int )
	ShadeMesh_( Byte Ptr(mesh), Byte Ptr(material) )
End Function

Function ShadeEntity( ent:Int, material:Int )
	ShadeEntity_( Byte Ptr(ent), Byte Ptr(material) )
End Function

Function SetFloat( material:Int, name:String, v1:Float )
	SetFloat_( Byte Ptr(material), name.ToCString(), v1 )
End Function

Function SetFloat2( material:Int, name:String, v1:Float, v2:Float )
	SetFloat2_( Byte Ptr(material), name.ToCString(), v1, v2 )
End Function

Function SetFloat3( material:Int, name:String, v1:Float, v2:Float, v3:Float )
	SetFloat3_( Byte Ptr(material), name.ToCString(), v1, v2, v3 )
End Function

Function SetFloat4( material:Int, name:String, v1:Float, v2:Float, v3:Float, v4:Float )
	SetFloat4_( Byte Ptr(material), name.ToCString(), v1, v2, v3, v4 )
End Function

Function UseFloat( material:Int, name:String, v1:Float Ptr )
	UseFloat_( Byte Ptr(material), name.ToCString(), v1 )
End Function

Function UseFloat2( material:Int, name:String, v1:Float Ptr, v2:Float Ptr )
	UseFloat2_( Byte Ptr(material), name.ToCString(), v1, v2 )
End Function

Function UseFloat3( material:Int, name:String, v1:Float Ptr, v2:Float Ptr, v3:Float Ptr )
	UseFloat3_( Byte Ptr(material), name.ToCString(), v1, v2, v3 )
End Function

Function UseFloat4( material:Int, name:String, v1:Float Ptr, v2:Float Ptr, v3:Float Ptr, v4:Float Ptr )
	UseFloat4_( Byte Ptr(material), name.ToCString(), v1, v2, v3, v4 )
End Function

Function SetInteger( material:Int, name:String, v1:Int )
	SetInteger_( Byte Ptr(material), name.ToCString(), v1 )
End Function

Function SetInteger2( material:Int, name:String, v1:Int, v2:Int )
	SetInteger2_( Byte Ptr(material), name.ToCString(), v1, v2 )
End Function

Function SetInteger3( material:Int, name:String, v1:Int, v2:Int, v3:Int )
	SetInteger3_( Byte Ptr(material), name.ToCString(), v1, v2, v3 )
End Function

Function SetInteger4( material:Int, name:String, v1:Int, v2:Int, v3:Int, v4:Int )
	SetInteger4_( Byte Ptr(material), name.ToCString(), v1, v2, v3, v4 )
End Function

Function UseInteger( material:Int, name:String, v1:Int Ptr )
	UseInteger_( Byte Ptr(material), name.ToCString(), v1 )
End Function

Function UseInteger2( material:Int, name:String, v1:Int Ptr, v2:Int Ptr )
	UseInteger2_( Byte Ptr(material), name.ToCString(), v1, v2 )
End Function

Function UseInteger3( material:Int, name:String, v1:Int Ptr, v2:Int Ptr, v3:Int Ptr )
	UseInteger3_( Byte Ptr(material), name.ToCString(), v1, v2, v3 )
End Function

Function UseInteger4( material:Int, name:String, v1:Int Ptr, v2:Int Ptr, v3:Int Ptr, v4:Int Ptr )
	UseInteger4_( Byte Ptr(material), name.ToCString(), v1, v2, v3, v4 )
End Function

Function UseSurface( material:Int, name:String, surf:Byte Ptr, vbo:Int )
	UseSurface_( Byte Ptr(material), name.ToCString(), surf, vbo )
End Function

Function UseMatrix( material:Int, name:String, mode:Int )
	UseMatrix_( Byte Ptr(material), name.ToCString(), mode )
End Function

Function LoadMaterial:Int( filename:String, flags:Int, frame_width:Int, frame_height:Int, first_frame:Int, frame_count:Int )
	Return Int( LoadMaterial_( filename.ToCString(), flags, frame_width, frame_height, first_frame, frame_count ) )
End Function

' Wrapped functions with argument defaults (can't be declared in globals)

Function BackBufferToTex( tex:Int, frame:Int=0 )
	BackBufferToTex_( Byte Ptr(tex), frame )
End Function

Function BufferToTex( tex:Int, buffer:Int, frame:Int=0 )
	BufferToTex_( Byte Ptr(tex), Byte Ptr(buffer), frame )
End Function

Function CameraToTex( tex:Int, cam:Int, frame:Int=0 )
	CameraToTex_( Byte Ptr(tex), Byte Ptr(cam), frame )
End Function

Function TexToBuffer( tex:Int, buffer:Int, frame:Int=0 )
	TexToBuffer_( Byte Ptr(tex), Byte Ptr(buffer), frame )
End Function

' Blitz3D functions, A-Z
Function AddVertex:Int( surf:Int, x:Float, y:Float, z:Float, u:Float=0, v:Float=0, w:Float=0 )
	Return AddVertex_( Byte Ptr(surf), x, y, z, u, v, w )
End Function

Function Animate( ent:Int, mode:Int=1, speed:Float=1, seq:Int=0, trans:Int=0 )
	Animate_( Byte Ptr(ent), mode, speed, seq, trans )
End Function

Function BrushTexture( brush:Int, tex:Int, frame:Int=0, index:Int=0 )
	BrushTexture_( Byte Ptr(brush), Byte Ptr(tex), frame, index )
End Function

Function ClearSurface( surf:Int, clear_verts:Int=True, clear_tris:Int=True )
	ClearSurface_( Byte Ptr(surf), clear_verts, clear_tris )
End Function

Function ClearWorld( entities:Int=True, brushes:Int=True, textures:Int=True )
	ClearWorld_( entities, brushes, textures )
End Function

Function Collisions( src_no:Int, dest_no:Int, method_no:Int, response_no:Int=0 )
	Collisions_( src_no, dest_no, method_no, response_no )
End Function

Function CopyEntity:Int( ent:Int, parent:Int=Null )
	Return Int( CopyEntity_( Byte Ptr(ent), Byte Ptr(parent) ) )
End Function

Function CopyMesh:Int( mesh:Int, parent:Int=Null )
	Return Int( CopyMesh_( Byte Ptr(mesh), Byte Ptr(parent) ) )
End Function

Function CreateBrush:Int( r:Float=255, g:Float=255, b:Float=255 )
	Return Int( CreateBrush_( r, g, b ) )
End Function

Function CreateCamera:Int( parent:Int=Null )
	Return Int( CreateCamera_( Byte Ptr(parent) ) )
End Function

Function CreateCone:Int( segments:Int=8, solid:Int=True, parent:Int=Null )
	Return Int( CreateCone_( segments, solid, Byte Ptr(parent) ) )
End Function

Function CreateCylinder:Int( segments:Int=8, solid:Int=True, parent:Int=Null )
	Return Int( CreateCylinder_( segments, solid, Byte Ptr(parent) ) )
End Function

Function CreateCube:Int( parent:Int=Null )
	Return Int( CreateCube_( Byte Ptr(parent) ) )
End Function

Function CreateMesh:Int( parent:Int=Null )
	Return Int( CreateMesh_( Byte Ptr(parent) ) )
End Function

Function CreateLight:Int( light_type:Int=1, parent:Int=Null )
	Return Int( CreateLight_( light_type, Byte Ptr(parent) ) )
End Function

Function CreatePivot:Int( parent:Int=Null )
	Return Int( CreatePivot_( Byte Ptr(parent) ) )
End Function

Function CreatePlane:Int( divisions:Int=1, parent:Int=Null )
	Return Int( CreatePlane_( divisions, Byte Ptr(parent) ) )
End Function

Function CreateShadow:Int( parent:Int, Static:Int=False )
	Return Int( CreateShadow_( Byte Ptr(parent), Static ) )
End Function

Function CreateSphere:Int( segments:Int=8, parent:Int=Null )
	Return Int( CreateSphere_( segments, Byte Ptr(parent) ) )
End Function

Function CreateSprite:Int( parent:Int=Null )
	Return Int( CreateSprite_( Byte Ptr(parent) ) )
End Function

Function CreateSurface:Int( mesh:Int, brush:Int=Null )
	Return Int( CreateSurface_( Byte Ptr(mesh), Byte Ptr(brush) ) )
End Function

Function CreateTerrain:Int( size:Int, parent:Int=Null )
	Return Int( CreateTerrain_( size, Byte Ptr(parent) ) )
End Function

Function CreateTexture:Int( width:Int, height:Int, flags:Int=1, frames:Int=1 )
	Return Int( CreateTexture_( width, height, flags, frames ) )
End Function

Function CreateVoxelSprite:Int( slices:Int=64, parent:Int=Null )
	Return Int( CreateVoxelSprite_( slices, Byte Ptr(parent) ) )
End Function

Function EntityParent( ent:Int, parent_ent:Int, glob:Int=True )
	EntityParent_( Byte Ptr(ent), Byte Ptr(parent_ent), glob )
End Function

Function EntityPickMode( ent:Int, pick_mode:Int, obscurer:Int=True )
	EntityPickMode_( Byte Ptr(ent), pick_mode, obscurer )
End Function

Function EntityPitch:Float( ent:Int, glob:Int=False )
	Return EntityPitch_( Byte Ptr(ent), glob )
End Function

Function EntityRadius( ent:Int, radius_x:Float, radius_y:Float=0 )
	EntityRadius_( Byte Ptr(ent), radius_x, radius_y )
End Function

Function EntityRoll:Float( ent:Int, glob:Int=True )
	Return EntityRoll_( Byte Ptr(ent), glob )
End Function

Function EntityTexture( ent:Int, tex:Int, frame:Int=0, index:Int=0 )
	EntityTexture_( Byte Ptr(ent), Byte Ptr(tex), frame, index )
End Function

Function EntityType( ent:Int, type_no:Int, recursive:Int=False )
	EntityType_( Byte Ptr(ent), type_no, recursive )
End Function

Function EntityX:Float( ent:Int, glob:Int=False )
	Return EntityX_( Byte Ptr(ent), glob )
End Function

Function EntityY:Float( ent:Int, glob:Int=False )
	Return EntityY_( Byte Ptr(ent), glob )
End Function

Function EntityYaw:Float( ent:Int, glob:Int=False )
	Return EntityYaw_( Byte Ptr(ent), glob )
End Function

Function EntityZ:Float( ent:Int, glob:Int=False )
	Return EntityZ_( Byte Ptr(ent), glob )
End Function

Function ExtractAnimSeq:Int( ent:Int, first_frame:Int, last_frame:Int, seq:Int=0 )
	Return ExtractAnimSeq_( Byte Ptr(ent), first_frame, last_frame, seq )
End Function

Function FitMesh( mesh:Int, x:Float, y:Float, z:Float, width:Float, height:Float, depth:Float, uniform:Int=False )
	FitMesh_( Byte Ptr(mesh), x, y, z, width, height, depth, uniform )
End Function

Function FreeShadow( shad:Int, Static:Int=False )
	FreeShadow_( Byte Ptr(shad), Static )
End Function

Function GetBrushTexture:Int( brush:Byte Ptr, index:Int=0 )
	Return Int( GetBrushTexture_( brush, index ) )
End Function

Function LinePick:Int( x:Float, y:Float, z:Float, dx:Float, dy:Float, dz:Float, radius:Float=0 )
	Return Int( LinePick_( x, y, z, dx, dy, dz, radius ) )
End Function

Function LoadAnimMesh:Int( file:String, parent:Int=Null )
	Return Int( LoadAnimMesh_( file.ToCString(), Byte Ptr(parent) ) )
End Function

Function LoadBrush:Int( file:String, flags:Int=1, u_scale:Float=1, v_scale:Float=1 )
	Return Int( LoadBrush_( file.ToCString(), flags, u_scale, v_scale ) )
End Function

Function LoadMesh:Int( file:String, parent:Int=Null )
	Return Int( LoadMesh_( file.ToCString(), Byte Ptr(parent) ) )
End Function

Function LoadTerrain:Int( file:String, parent:Int=Null )
	Return Int( LoadTerrain_( file.ToCString(), Byte Ptr(parent) ) )
End Function

Function LoadTexture:Int( file:String, flags:Int=1 )
	Return Int(LoadTexture_( file.ToCString(), flags ))
End Function

Function LoadSprite:Int( tex_file:String, tex_flag:Int=1, parent:Int=Null )
	Return Int( LoadSprite_( tex_file.ToCString(), tex_flag, Byte Ptr(parent) ) )
End Function

Function MeshCSG:Int( m1:Int, m2:Int, method_no:Int=1 )
	Return Int( MeshCSG_( Byte Ptr(m1), Byte Ptr(m2), method_no ) )
End Function

Function PointEntity( ent:Int, target_ent:Int, roll:Float=0 )
	PointEntity_( Byte Ptr(ent), Byte Ptr(target_ent), roll )
End Function

Function PositionEntity( ent:Int, x:Float, y:Float, z:Float, glob:Int=False )
	PositionEntity_( Byte Ptr(ent), x, y, z, glob )
End Function

Function RepeatMesh:Int( mesh:Int, parent:Int=Null )
	Return Int( RepeatMesh_( Byte Ptr(mesh), Byte Ptr(parent) ) )
End Function

Function RotateEntity( ent:Int, x:Float, y:Float, z:Float, glob:Int=False )
	RotateEntity_( Byte Ptr(ent), x, y, z, glob )
End Function

Function ScaleEntity( ent:Int, x:Float, y:Float, z:Float, glob:Int=False )
	ScaleEntity_( Byte Ptr(ent), x, y, z, glob )
End Function

Function SetAnimTime( ent:Int, time:Float, seq:Int=0 )
	SetAnimTime_( Byte Ptr(ent), time, seq )
End Function

Function StencilMesh( stencil:Int, mesh:Int, mode:Int=1 )
	StencilMesh_( Byte Ptr(stencil), Byte Ptr(mesh), mode )
End Function

Function TranslateEntity( ent:Int, x:Float, y:Float, z:Float, glob:Int=False )
	TranslateEntity_( Byte Ptr(ent), x, y, z, glob )
End Function

Function TurnEntity( ent:Int, x:Float, y:Float, z:Float, glob:Int=False )
	TurnEntity_( Byte Ptr(ent), x, y, z, glob )
End Function

Function UpdateWorld( anim_speed:Float=1 )
	UpdateWorld_( anim_speed )
End Function

Function VertexColor( surf:Int, vid:Int, r:Float, g:Float, b:Float, a:Float=1 )
	VertexColor_( Byte Ptr(surf), vid, r, g, b, a )
End Function

Function VertexTexCoords( surf:Int, vid:Int, u:Float, v:Float, w:Float=0, coord_set:Int=0 )
	VertexTexCoords_( Byte Ptr(surf), vid, u, v, w, coord_set )
End Function

Function VertexU:Float( surf:Int, vid:Int, coord_set:Int=0 )
	Return VertexU_( Byte Ptr(surf), vid, coord_set )
End Function

Function VertexV:Float( surf:Int, vid:Int, coord_set:Int=0 )
	Return VertexV_( Byte Ptr(surf), vid, coord_set )
End Function

Function VertexW:Float( surf:Int, vid:Int, coord_set:Int=0 )
	Return VertexW_( Byte Ptr(surf), vid, coord_set )
End Function

' ***extras***
Function EntityScaleX:Float( ent:Int, glob:Int=False )
	Return EntityScaleX_( Byte Ptr(ent), glob )
End Function

Function EntityScaleY:Float( ent:Int, glob:Int=False )
	Return EntityScaleY_( Byte Ptr(ent), glob )
End Function

Function EntityScaleZ:Float( ent:Int, glob:Int=False )
	Return EntityScaleZ_( Byte Ptr(ent), glob )
End Function

Function ShaderTexture( material:Int, tex:Int, name:String, index:Int=0 )
	ShaderTexture_( Byte Ptr(material), Byte Ptr(tex), name.ToCString(), index )
End Function

Function ShaderMaterial( material:Int, tex:Int, name:String, index:Int=0 )
	ShaderMaterial_( Byte Ptr(material), Byte Ptr(tex), name.ToCString(), index )
End Function

Function CreateOcTree:Int( w:Float, h:Float, d:Float, parent_ent:Int=Null )
	Return Int( CreateOcTree_( w, h, d, Byte Ptr(parent_ent) ) )
End Function

Function OctreeBlock( octree:Int, mesh:Int, level:Int, X:Float, Y:Float, Z:Float, Near:Float=0, Far:Float=1000 )
	OctreeBlock_( Byte Ptr(octree), Byte Ptr(mesh), level, X, Y, Z, Near, Far )
End Function

Function OctreeMesh( octree:Int, mesh:Int, level:Int, X:Float, Y:Float, Z:Float, Near:Float=0, Far:Float=1000 )
	OctreeMesh_( Byte Ptr(octree), Byte Ptr(mesh), level, X, Y, Z, Near, Far )
End Function

