' ID: 2597
' Author: GfK
' Date: 2009-10-20 09:24:28
' Title: Lines Intersect
' Description: Calculate the intersection point of two lines

Strict

'THE MATHS BIT


	Function intersect(x1:Double, y1:Double, x2:Double, y2:Double, u1:Double, v1:Double, u2:Double, v2:Double, xResult:Double var, yResult:Double var)
		Local m1:Double, m2:Double, b1:Double, b2:Double
		
		'CALCULATE SLOPE OF EACH LINE AND CHECK FOR POTENTIAL DIVISION-BY-ZERO 
		If (x2 - x1) <> 0
			m1 = (y2 - y1) / (x2 - x1)
		Else
			m1 = (y2 - y1)
		EndIf
		If (u2 - u1) <> 0
			m2 = (v2 - v1) / (u2 - u1)
		Else
			m2 = (v2 - v1)
		EndIf
		
		b1 = y1 - (m1 * x1)
		b2 = v1 - (m2 * u2)

		xresult = (v1 - y1 - (u1 * m2) + (x1 * m1)) / (m1 - m2)
		yResult = m1 * xResult + b1

		'NOTES
		'If m1 = m2 then both lines are parallel and will never intersect.
		'If m1 = m2 AND b1 = b2, then both lines are colinear (i.e. the same).
	End Function


'END OF MATHS BIT


'DEMO CODE

Graphics 800, 600

'define two lines as four pairs of x/y coordinates:
'line 1
Local x1:Double = 60, y1:Double = 450
Local x2:Double = 300, y2:Double = 50 'don't really need this as we'll use the mouse coords.
'line 2
Local u1:Double = 50, v1:Double = 100
Local u2:Double = 700, v2:Double = 525

'These vars will contain the intersection point.
Local xC:Double, yC:Double

While Not KeyDown(KEY_ESCAPE)
	intersect(x1, y1, Double(MouseX()), Double(MouseY()), u1, v1, u2, v2, xC, yC) 'calculate the point of intersection (xC and yC)
	Cls
	Draw(x1, y1, MouseX(), MouseY(), u1, v1, u2, v2) 'Draw the lines
	SetColor 0, 0, 255
	DrawOval xC - 5, yC - 5, 10, 10 'Draw oval at intersection point
	Flip
Wend

Function Draw(x1:Double, y1:Double, x2:Double, y2:Double, u1:Double, v1:Double, u2:Double, v2:Double)
	SetColor 255, 255, 0
	DrawLine x1, y1, x2, y2
	SetColor 255, 0, 0
	DrawLine u1, v1, u2, v2
End Function
'END OF DEMO CODE

