' ID: 3124
' Author: munch
' Date: 2014-05-10 00:06:44
' Title: Get online doc examples
' Description: Gets code examples from the online manual and adds them to the docs

' Get online doc examples.bmx
'
' Gets code examples from the online manual and adds them to the docs

SuperStrict

Local p:GetHttpCode = New GetHttpCode

p.FindAll()

End

Type GetHttpCode
	Field filei%,files$[1000],mdir$=FindDocs()
	
	Method FindAll()
		If FileType("Modules")=0 ' no modules folder
			Print "Creating Modules folder"
			HttpFindFiles(mdir) ' get online examples
		Else
			Print "Modules folder already exists"
		EndIf
		
		CodeFindFiles("Modules") ' copy files
		
		CodeSaveFuncs()
		
		HtmlFindFiles(mdir) ' add to html files
	End Method
	
	Method FindDocs$()
		Local wdir$=CurrentDir()+"/" ' find the docs
		Local ldir$=wdir.Tolower() ' lowercase
		Local bms%=ldir.Find("blitzmax",0) ' bmax start
		If bms=-1 RuntimeError "Failed to find blitzmax directory"
		
		Local bme%=ldir.Find("/",bms) ' bmax end
		Return wdir[..bme]+"/docs/html/Modules" ' modules dir
	End Method
	
	' part 1: get code from http files
	
	Method HttpFindFiles(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=2 Then HttpFindFiles2(cfile) ' directory
		Forever
	
		CloseDir dh
	End Method

	Method HttpFindFiles2(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory l2"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=2 Then HttpFindFiles3(cfile) ' directory
		Forever
		
		CloseDir dh
	End Method

	Method HttpFindFiles3(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory l3"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=1 ' file, html
				If ExtractExt(cfile)="html" Then HttpOpenHtml(cfile)
			EndIf
		Forever
		
		CloseDir dh
	End Method

	Method HttpOpenHtml(path$)
	
		Local file:TStream=OpenFile(path)
		If Not file RuntimeError "could not open html file"
	
		While Not Eof(file)
			Local html$=ReadString(file,FileSize(path))
			Local html2$,link$,code$
			Local fr%=html.Find("Function reference",0)
			Local fts%=fr,fbs%,fen%,fte%,fbe%
			
			If fr>0 ' file has functions
			Print "Reading: "+path[mdir.length+1..path.Find("index.html",mdir.length)-1]
			
				While fts>-1 ' while functions in file
					fts=html.Find("colspan=2>Function ",fts+1)
					If fts>0
						fts:+19 ' to function name
						fbs=html.Find("(",fts) ' bracket start
						fte=html.Find("</td>",fts) ' table end
						fen=html[fts..fbs].Find(":",0) ' type (end of func name)
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("[",0) ' array
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("$",0) ' string
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("#",0) ' float
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("!",0) ' double
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("_",0)
						
						If fen=-1 ' not a lua_func
							fen=html[fts..fbs].Find(" ",0) ' trim spaces
							If fen>0 Then fbs=fts+fen
							Local func$=html[fts..fbs] ' get func name
							fbe=html[fts..fte].Find("NoDebug",0) ' bracket end or nodebug
							If fbe=-1 Then fbe=html[fts..fte].FindLast(")",0) Else fbe:+6
							fbe:+fts+1
							link="http::www.blitzmax.com/bmdocs/command.php?name="+func+"&ref=goto"
							code=HttpOpen(link,func)
							If code.length>0 Then HttpSaveCode(path,func,code)
						EndIf
					EndIf
				Wend
				
			EndIf
		Wend
		
		CloseStream file
	End Method

	Method HttpOpen$(url$,func$)
	
		Local in:TStream=ReadStream(url)
		If Not in RuntimeError "Failed to open a ReadStream to http file"
		
		Local http$
		While Not Eof(in)
			http:+ReadLine(in)+"~n"
		Wend
		
		Local user$,code$
		Local tmp%,cs%,ps%,ai%,opf%,pe%,ui%,tmp2%,gt%,cu%,cc%
		Local paf%[1000],ua%[1000],pa%[1000]
		
		Print func
		cs=http.Find("<a name="+Chr(34)+"comments"+Chr(34)+">",0)
		If cs=-1 Then CloseStream in ; Return "" ' no entry in bmdocs
		
		ps=0
		While ps>-1
			ps=http.Find("<pre class=code>",ps+1)
			If ps>0 Then  pa[ai]=ps ; ai:+1 ' pre array
		Wend
		ps=0
		While ps>-1
			ps=http.Find("<textarea class=codebox ",ps+1)
			If ps>0 Then pa[ai]=ps ; ai:+1
		Wend
		ps=0
		While ps>-1
			ps=http.Find("<td class="+Chr(34)+"posthead"+Chr(34)+">",ps+1)
			If ps>0 Then  ua[ui]=ps ; ui:+1 ' username array
		Wend
		For tmp=0 To ai-1
			If pa[tmp]<cs Then opf=pa[tmp] ; Exit ' official pre found
		Next
		If opf ' official pre
			pe=http.Find("</pre>",opf)
			code=http[opf+16..pe].Trim() ' get the code
			CloseStream in
			Return code
		EndIf
		ua[ui]=-1 ' last user
		For tmp=0 To ai-1
			For tmp2=0 To ui-1
				If tmp2=ui-1 Then gt=pa[tmp]+1 Else gt=ua[tmp2+1] ' greater
				If pa[tmp]>ua[tmp2] And pa[tmp]<gt ' pre between these values
					cu=ua[tmp2] ' user
					If paf[tmp2]=0 Then cc=pa[tmp] ; paf[tmp2]=cc ' last user with first code example
				EndIf
			Next
		Next
		If cu=0 And cc=0 Then CloseStream in ; Return "" ' no code examples
		
		ps=http.Find("<td >",cu) ' get username
		tmp=http[ps..ps+9].Find("<a href=",0) ' check for link
		If tmp>-1 Then ps=http.Find("</a>",tmp)
		tmp2=http.Find("</td>",ps)
		user=http[ps+5..tmp2]
		
		tmp=http[cc..cc+9].Find("<pre ",0) ' get example
		If tmp=-1 Then pe=http.Find("</textarea>",cc) Else pe=http.Find("</pre>",cc)
		tmp2=http.Find(">",cc)+1
		code=http[cc..pe].Trim()
		tmp=code.Find("~n",0)
		If tmp2>-1 Then code=code[tmp..].Trim()
		tmp2=code.Find(".bmx",0)
		code="' "+func.Tolower()+".bmx ("+user+")~n~n"+code
		
		CloseStream in
		Return code
		
	End Method

	Method HttpSaveCode(path$,func$,code$)
	
		Local success%,fs%,fs2%,file:TStream
		Local lpath$,ldir2$,ldir3$,ldir$
		
		ldir="Modules"
		If FileType(ldir)=0
			success=CreateDir(ldir)
			If Not success RuntimeError "error creating directory"
		EndIf
		
		fs=path.Find("/",mdir.length+1) ' directory level 2
		ldir2=ldir+path[mdir.length..fs]
		If FileType(ldir2)=0
			success=CreateDir(ldir2)
			If Not success RuntimeError "error creating directory l2"
		EndIf
		
		fs2=path.Find("/",fs+1) ' directory level 3
		ldir3=ldir+path[mdir.length..fs]+path[fs..fs2]
		If FileType(ldir3)=0
			success=CreateDir(ldir3)
			If Not success RuntimeError "error creating directory l3"
		EndIf
		
		lpath=ldir+path[mdir.length..fs]+path[fs..fs2]+"/"+func.Tolower()+".bmx" ' local file path
		file=WriteFile(lpath)
		If Not file RuntimeError "failed to open file" 
		WriteLine file,code
		CloseStream file
		
	End Method

	' part 2: copy local files to docs/html
	
	Method CodeFindFiles(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=2 Then CodeFindFiles2(cfile) ' directory
		Forever
	
		CloseDir dh
	End Method

	Method CodeFindFiles2(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory l2"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=2 Then CodeFindFiles3(cfile) ' directory
		Forever
		
		CloseDir dh
	End Method

	Method CodeFindFiles3(dir$)
		Local ddir$,temp$
		Local dh%,fp%
		
		dh=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory l3"
		
		Repeat
			temp=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			fp=cfile.Find("/",0)
			ddir=mdir+cfile[fp..]
			If FileSize(ddir)=-1 ' file, bmx
				files[filei]=cfile ' store local file path
				filei:+1
				CopyFile(cfile,ddir) ' copy from local to docs/html
			EndIf
			
		Forever
		
		CloseDir dh
		
	End Method

	Method CodeSaveFuncs()
		Local fi%,file:TStream
		
		If FileSize("Modules/log.txt")=-1 ' file doesn't exist
			file=WriteFile("Modules/log.txt")
			If Not file RuntimeError "failed to open file"
			
			For fi=0 To filei-1 ' file index
				WriteLine file,files[fi]
			Next
			CloseStream file
		EndIf
	End Method
	
	' part 3: add code examples to docs/html
	
	Method HtmlFindFiles(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=2 Then HtmlFindFiles2(cfile) ' directory
		Forever
	
		CloseDir dh 
	End Method

	Method HtmlFindFiles2(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory l2"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=2 Then HtmlFindFiles3(cfile) ' directory
		Forever
		
		CloseDir dh
	End Method

	Method HtmlFindFiles3(dir$)
		Local dh%=ReadDir(dir)
		If Not dh RuntimeError "failed to read current directory l3"
	
		Repeat
			Local temp$=NextFile(dh)
			If temp="" Then Exit ' done
			If temp="." Or temp=".." Continue ' skip
			Local cfile$=dir+"/"+temp ' current file
			If FileType(cfile)=1 ' file, html
				If ExtractExt(cfile)="html" Then HtmlOpenHtml(cfile)
			EndIf
		Forever
		
		CloseDir dh
	End Method

	Method HtmlOpenHtml(path$)
		Local html$,html2$,code$,row$
		Local file:TStream=OpenFile(path)
		If Not file RuntimeError "could not open file"
		
		While Not Eof(file)
			html=ReadString(file,FileSize(path))
			Local fr%=html.Find("Function reference",0)
			Local fts%=fr
			Local fbs%,fen%,fte%,fls%,fep%,fer%,fet%,fri%,flr%,fhe%,fni%,fne%,fnt%,lnt%,fnf%
			
			If fr>0 ' file has functions
			html2=html
			
				While fts>-1 ' while functions in file
					fts=html.Find("colspan=2>Function ",fts+1) ' table start
					If fts>0
						fts:+19 ' to function name
						fbs=html.Find("(",fts) ' bracket start
						fte=html.Find("</td>",fts) ' table end
						fen=html[fts..fbs].Find(":",0) ' type (end name)
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("[",0) ' array
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("$",0) ' string
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("#",0) ' float
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("!",0) ' double
						If fen>0 Then fbs=fts+fen
						fen=html[fts..fbs].Find("_",0)
						
						If fen=-1 ' not a lua_func
							fen=html[fts..fbs].Find(" ",0) ' trim spaces
							If fen>0 Then fbs=fts+fen
							Local func$=html[fts..fbs] ' get func name
							
							For fni=0 To filei-1 ' new index
								fls=files[fni].FindLast("/",0)+1 ' last slash
								fep=files[fni].Find(".bmx",fls) ' extension pos
								If files[fni][fls..fep]=func.Tolower()
									fne=html.Find("<table class=doc ",fbs) ' next entry
									If fne=-1 Then fne=html.Find("</body>",fbs)
									fet=html.Find("</table>",fbs) ' end table
									
									fnt=fbs
									For fri=0 To 3 ' last nested table
										lnt=fnt
										fnt=html.Find("<table>",fnt+1) ' nested table
										If fnt<fne And fnt>0 Then fnt=lnt ; Exit ' is nested
									Next
									fnf=0
									If fnt<fne And fnt>0 ' found nested table
										fet=html.Find("</table>",fnt)
										fnf=html.Find("</tr>",fet)
										fet=html.Find("</table>",fet)
									EndIf
									fer=fbs ' end row
									For fri=0 To 19 ' row index
										flr=fer ' last row
										fer=html.Find("</tr>",fer+1)
										
										If fer>fet Or fer=-1
											flr:+5
											If fnf Then flr=fnf+5
											Exit
										EndIf
									Next
									
									fhe=html.Find("Example</a>",fbs) ' has example									
									If fhe=-1 Or fhe>fet ' no example found
										code=HtmlReadCode(files[fni])
										Print "Adding Examples: "+files[fni]
										
										row="~n<tr><td class=docleft width=1%><a href="
										row:+Chr(34)+func.Tolower()+".bmx"+Chr(34)
										row:+">Example</a></td><td class=docright><pre>"
										row:+code+"</pre>~n</td></tr>"
										html2=html[..flr]+row+html[flr..]
									EndIf
																
								EndIf
							Next
							
						EndIf
					EndIf
					html=html2 ' update html
				Wend
				
			EndIf
		Wend
		
		SeekStream file,0 ' overwrite file
		WriteString file,html
		CloseStream file
	End Method

	Method HtmlReadCode$(path$)
		Local file:TStream=ReadFile(path)
		If Not file RuntimeError "could not open file"
		
		Local code$=ReadString(file,FileSize(path))
		
		CloseStream file
		Return code
	End Method

End Type

