' ID: 2135
' Author: Madk
' Date: 2007-11-02 21:38:12
' Title: Polygon and Star functions
' Description: Easily draw shapes in Max2d on the fly!

'*-------------------------------------------------------*'
'*--Polygon and Star functions coded by Madk on 11-2-07--*'
'*-------------------------------------------------------*'

'   No credit is needed for use of these functions.



Global B3DM_xp[360],B3DM_yp[360] 'These arrays must be declared at start of code for the functions to work.



'Example Usage
Graphics 640,480,0,60

SetColor 255,255,255
Repeat
	Cls
	
	For Local a=5 To 8
		Polygon 70+(a-4)*100, 100, 70, 70, a, -90
		Star    70+(a-4)*100, 100, 70, 70, a, -90
	Next
	
	Flip
	If KeyDown(KEY_ESCAPE) End
Forever


'Polygon draws a shape with the specified number of sides
'Polygon ( x position, y position, width, height, number of sides, angle at which to draw = 0 )
Function Polygon(x#,y#,w#,h#,s%,ang#=0)
	Local dop,lin
	If s>360 Then s=360
	s=s-1;w=w/2;h=h/2
	For dop=0 To s
		B3DM_xp[dop]=x+w*(Cos((360/(s+1)*dop)+ang))
		B3DM_yp[dop]=y+h*(Sin((360/(s+1)*dop)+ang))
	Next
	For lin=0 To s
		p2=lin+1;If p2>s Then p2=0
		DrawLine B3DM_xp[lin],B3DM_yp[lin],B3DM_xp(p2),B3DM_yp(p2)
	Next
End Function

'Star uses a mathematical formula to connect the points of a ploygon to form a star
'Star ( x position, y position, width, height, number of points, angle at which to draw = 0 )
Function Star(x#,y#,w#,h#,s%,ang#=0) 
	Local dop,lin
	If s>360 Then s=360
	s=s-1;w=w/2;h=h/2
	For dop=0 To s
		B3DM_xp[dop]=x+w*(Cos((360/(s+1)*dop)+ang))
		B3DM_yp[dop]=y+h*(Sin((360/(s+1)*dop)+ang))
	Next
	For lin=0 To s
		p2=lin+2;If p2=s+1 Then p2=0 ElseIf p2=s+2 Then p2=1
		DrawLine B3DM_xp[lin],B3DM_yp[lin],B3DM_xp(p2),B3DM_yp(p2)
	Next
End Function

