' ID: 2376
' Author: Weijtenburg
' Date: 2008-12-21 05:25:50
' Title: Super fast Pixmap or Image to Pixmap + Alpha + Colorizer
' Description: This code has functions for super fast Pixmap / Image to Pixmap pasting with Alpha and Colorizer! support

'DrawOnPixmap
Function DrawOnPixmap(image:TImage, framenr:Int = 0, pixmap:TPixmap, x:Int, y:Int, alpha:Float = 1.0, colorize:Int = 0) 
	Local imagepix:TPixmap = Null
	
	If framenr = 0 imagepix = LockImage(image) 
	If framenr > 0 imagepix = LockImage(image, framenr)
	
	DrawPixmapOnPixmap(imagepix, framenr, pixmap, x, y, alpha, colorize) 
	
	If framenr = 0 UnlockImage(image) 
	If framenr > 0 UnlockImage(image, framenr) 
End Function

'DrawPixmapOnPixmap
Function DrawPixmapOnPixmap(imagepix:TPixmap, framenr:Int = 0, pixmap:TPixmap, x:Int, y:Int, alpha:Float = 1.0, colorize:Int = 0) 
	Local sourcepixel:Int 
	Local sourceA:Float 
	Local sourceR:Float 
	Local sourceG:Float 
	Local sourceB:Float 
	Local destpixel:Int
	Local destA:Float 
	Local destR:Float 
	Local destG:Float
	Local destB:Float
	Local Xalpha:Int 
	Local colorA:Float 
	Local colorR:Float 
	Local colorG:Float 
	Local colorB:Float 
	Local CLalpha:Float 
	
	Local w:Int = PixmapWidth(imagepix) - 1
	Local h:Int = PixmapHeight(imagepix) - 1
	Local i:Int
	Local j:Int
	
	For i = 0 To w 
		For j = 0 To h
			If x + i < pixmap.width And y + j < pixmap.Height
				
				'Source
				sourcepixel = ReadPixel(imagepix, i, j) 
				sourceA = ARGB_A(sourcepixel) * alpha
				If sourceA <> 0 Then
					sourceR = ARGB_R(sourcepixel) 
					sourceG = ARGB_G(sourcepixel) 
					sourceB = ARGB_B(sourcepixel)
					 
					'Colorize
					colorA = ARGB_A(colorize) 
					If colorA <> 0
						colorR = ARGB_R(colorize) 
						colorG = ARGB_G(colorize) 
						colorB = ARGB_B(colorize) 
						
						If colorA <> 255 Then
							sourceR = sourceR + ((colorR - sourceR) * colorA / 255)
							sourceG = sourceG + ((colorG - sourceG) * colorA / 255)
							sourceB = sourceB + ((colorB - sourceB) * colorA / 255)
						Else
							sourceR = colorR
							sourceG = colorG
							sourceB = colorB
						End If
					End If
					
					'Blend (if has alpha and is not transperant)
					Xalpha = sourceA
					If sourceA <> 255 Then
						destpixel = ReadPixel(pixmap, x + i, y + j) 
						destA = ARGB_A(destpixel) 
						destR = ARGB_R(destpixel) 
						destG = ARGB_G(destpixel) 
						destB = ARGB_B(destpixel) 
						Xalpha = destA + sourceA
					
						sourceR = (sourceR * sourceA / Xalpha) + (destA / Xalpha * (destR * destA / Xalpha))
						sourceG = (sourceG * sourceA / Xalpha) + (destA / Xalpha * (destG * destA / Xalpha))
						sourceB = (sourceB * sourceA / Xalpha) + (destA / Xalpha * (destB * destA / Xalpha))
						If Xalpha > 255 Then Xalpha = 255
					EndIf
					
					'If visable pixel
					WritePixel(Pixmap, x + i, y + j, ARGB(Xalpha, sourceR, sourceG, sourceB)) 
				End If
			EndIf
		Next
	Next
End Function

'DrawOnPixmap helpers
Function ARGB_R:Int(r:Int)
	Return (r Shr 16) & $FF
End Function

Function ARGB_G:Int(g:Int)
	Return (g Shr 8) & $FF
End Function

Function ARGB_B:Int(b:Int)
	Return b & $FF
End Function

Function ARGB_A:Int(a:Int) 
	Return (a Shr 24) & $FF
End Function

Function ARGB:Int(a:Int, r:Int, g:Int, b:Int) 
	Return Int(a * $1000000) + Int(r * $10000) + Int(g * $100) + Int(b)
End Function

