' ID: 2840
' Author: GfK
' Date: 2011-04-27 04:14:13
' Title: FONText 1.65 for Blitzmax
' Description: Use FONText fonts and ini files from within Blitzmax

Type BitmapFont
	Method Initialise(path:String,FileFormat:String)
		Font_LoadImage(path+"."+FileFormat)
		Font_LoadINIFile(path + ".ini")
	End Method

	Method Font_LoadImage(path:String)
		image = LoadImage(path, FILTEREDIMAGE | MIPMAPPEDIMAGE)
	End Method

	Method Font_LoadINIFile(path:String)
		Local FILE:TStream = ReadFile(path)
		Local s:String
		Local Marker:String = ""
		Local Pos:Int, N:Int, c1:Byte,c2:Byte
		If FILE
			Repeat
				s = ReadLine(FILE)
				If Left$(s,1) = "[" And Right$(s,1) = "]"
					'found section marker
					Marker = Lower$(s)
				EndIf
				Select marker
					Case "[global]"
						If Lower$(Left$(s,5)) = "width"
							Pos:Int = Instr(s,"=")+1
							bitmapWidth = Int(Mid(s,Pos,Len(s)-Pos+1))
						EndIf
						If Lower$(Left$(s,6)) = "height"
							Pos:Int = Instr(s,"=")+1
							bitmapHeight = Int(Mid(s,Pos,Len(s)-Pos+1))
						EndIf
					Case "[text]"
						If Lower$(Left$(s,9)) = "blocksize"
							Pos:Int = Instr(s,"=")+1
							blockSize = Int(Mid(s,Pos,Len(s)-Pos+1))
						EndIf
					Case "[charset]"
						If Mid(s,2,1) = "="
							Local N:Int = 0
							N = Asc(Left$(s,1))
							char[N] = New tempChar
							char[N].char = Left$(s,1)
							c1:Byte = Instr(s,",",2)
							c2:Byte = Instr(s,",",c1+1)
							char[N].x = Int(Mid(s,3,c1-3))
							char[N].y = Int(Mid(s,c1+1,c2-(c1+1)))
							char[N].width = Int(Right$(s,Len(s)-c2))
						EndIf
					End Select
			Until Eof(FILE)
			CloseFile FILE
			'grab characters from image
			Local x:Int = 0
			Local y:Int = 0
			Local color:Int = 0
			For N = 0 To 255
				If char[N] <> Null
					Frame[N] = LoadImage(PixmapWindow(LockImage(image), char[N].x, char[N].y, 64, blockSize), FILTEREDIMAGE | MIPMAPPEDIMAGE)
					SetImageHandle Frame[N], 32 - (char[N].width * 0.5), Frame[N].Height * 0.5
					char[n].width :+ 2
				EndIf
			Next
		EndIf	
	End Method
	
	Method StringWidth:Float(Word:String)
		Local scalex:Float,scaley:Float
		Local spaceSize:Int = spacesize
		Local tempWidth:Float = 0
		Local n:Int,c:Int
		GetScale scalex,scaley
			SetScale 1,1
			For N = 1 To Len(word)
				c = Asc(Mid(word,N,1))
				If c <> 32
					If Frame[c] <> Null
						tempWidth = tempWidth + (char[c].width*Spacing)
					EndIf
				Else
					tempWidth = tempWidth+ (spaceSize*Spacing)
				EndIf
			Next
			SetScale scalex,scaley
		Return tempwidth' * scalex
	End Method
	
	Method text(s:String,x:float,y:float,justify:Byte = 0)
		'justify 0-left, 1-centre, 2-right
		Local xP:Float = x
		Local yP:Float = y
		Local N:Int = 0
		Local c:Int
		Local scalex:Float,scaley:Float
		GetScale scalex,scaley
		Local tempWidth:Double = 0

		If justify <> 0
			For N = 1 To Len(s)
				c = Asc(Mid(s,N,1))
				If c <> 32
					If Frame[c] <> Null
						tempWidth = tempWidth + (char[c].width*Spacing)
					EndIf
				Else
					tempWidth = tempWidth+ (spaceSize*Spacing)
				EndIf
			Next
			tempwidth :* scalex
			If justify = 1
				xp:-(tempwidth/2.0)
			ElseIf justify = 2
				xp:-tempwidth
			EndIf
		EndIf

		For N = 1 To Len(s)
			c = Asc(Mid(s,N,1))
			If c <> 32
				If Frame[c] <> Null
					DrawImage Frame[c],xp,yp
					xP :+ ((char[c].width * Spacing) * scalex)
				EndIf
			Else
				xP :+ ((spaceSize * Spacing) * scalex)
			EndIf
		Next
	End Method
	
	Field char:tempChar[256]
	Field blockSize:Int
	Field Spacing:Float = 1
	Field spaceSize:Int = 16
	Field image:TImage
	Field bitmapWidth:Int
	Field bitmapHeight:Int
	Field Frame:TImage[256]

End Type

Type tempChar
	Field char:String
	Field x:Int
	Field y:Int
	Field width:Int
End Type

