' ID: 1978
' Author: GfK
' Date: 2007-04-01 21:32:20
' Title: GetVersionString()
' Description: Determine Windows OS version

Extern "win32"
        Function GetVersionExA(infoex:Byte Ptr)
End Extern

Print getVersionString()

Function getVersionString:String()
	Local VER_PLATFORM_WIN32s = 0
	Local VER_PLATFORM_WIN32_WINDOWS = 1
	Local VER_PLATFORM_WIN32_NT = 2

	Local versionName:String
	Local VersionInfo:OSVersionInfoEx=New OSVersionInfoEx
	VersionInfo.dwOSVersionInfoSize=SizeOf(VersionInfo)
	
	GetVersionExA(VersionInfo)
	Select versionInfo.dwPlatformID
		Case VER_PLATFORM_WIN32s; VersionName = "Win32s"
		Case VER_PLATFORM_WIN32_NT; VersionName = "Windows NT"
	         
		Select versionInfo.dwVerMajor
			Case 4; VersionName = "Windows NT"
			Case 5;
				Select versionInfo.dwVerMinor
					Case 0; VersionName = "Windows 2000"
					Case 1; VersionName = "Windows XP"
				End Select
			Case 6;
				Select versionInfo.dwVerMinor
					Case 0; VersionName = "Windows Vista"
					Case 1; VersionName = "Windows 7"
				End Select
		End Select
	                  
		Case VER_PLATFORM_WIN32_WINDOWS
			Select versionInfo.dwVerMinor
				Case 0; VersionName = "Windows 95"
				Case 90; VersionName = "Windows ME"
				Case 10; VersionName = "Windows 98"
			End Select
	End Select
	Return VersionName
End Function


Type OSVersionInfoEx
	Field dwOSVersionInfoSize:Int
	Field dwVerMajor:Int
	Field dwVerMinor:Int
	Field dwBuildNumber:Int
	Field dwPlatformId:Int

	Field szCSDVersion:Int

	Field pad0:Long
	Field pad1:Long
	Field pad2:Long
	Field pad3:Long
	Field pad4:Long
	Field pad5:Long
	Field pad6:Long
	Field pad7:Long
	Field pad8:Long
	Field pad9:Long
	Field pad10:Long
	Field pad11:Long
	Field pad12:Long
	Field pad13:Long
	Field pad14:Long
	Field pad15:Int

	Field wServicePackMajor:Short
	Field wServicePackMinor:Short
	Field wSuiteMask:Short
	Field wProductType:Byte
	Field wReserved:Byte
End Type

